/***

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is StumbleUpon code.
The Initial Developer of the Original Code is StumbleUpon.

Portions created by StumbleUpon are
Copyright (C) 2002-2005 StumbleUpon.  All
Rights Reserved.

Original Author: Geoff Smith <geoff@stumbleupon.com>
Contributor(s): Garrett Camp <gmc@stumbleupon.com>
		loonyone <loonyone.stumbleupon.com>
		Joe Walp <joewalp@yahoo.com>

***/

//********* INITIALIZATION *****************//


//su_jslib.init(this);
//su_include(su_jslib_file);

// version stuff
var su_private_label = "BETA";

var mozbar_version = "1.9996";
var su_servername = 'stumbleupon.com';
var su_serverhttp = 'http://www.' + su_servername + '/';
var su_random_delay = 0;
var su_cacheTimer = 0;
var su_prefetch_url = "";
var rate_url = "";
var unrate_url = "";
var rate_rating = "";
var rate_stumble_on_rate = 0;
var su_useragent = "mozbar " + mozbar_version + " xpi";
if (su_private_label != "")
	su_useragent += " " + su_private_label;


// Localization (need to actually use bundle...)
var src = 'chrome://stumbleupon/locale/stumbleupon.properties';
var localeService = Components.classes["@mozilla.org/intl/nslocaleservice;1"].getService(Components.interfaces.nsILocaleService);
var appLocale =  localeService.getApplicationLocale();
var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
var su_bundle = stringBundleService.createBundle(src, appLocale);

// alert(su_bundle.GetStringFromName("menu.anytopic"));


var firstraters = new Object(); // stores a map of TLD's -> firstraters
var su_topics = new Object();   // stores a map of TLD's -> topics
var su_google_links = new Array(); // stores google results

var su_changeInterval = null;
var bad_stumble = true;
var great_stumble = false;
var su_check_referral = 0;
var su_toolbar_disabled = false;
var rate_opens_tab = 0;

var su_switched_listeners = 0;
var recommend_callback = null;
var unseen_callback = null;
var g_force_nostumble = 0;
var g_user_cat = 0;
var g_middle_click = 0;
var photoblogimage = "";
var su_verstring = escape(su_useragent);
var su_base_url = su_serverhttp;
var first_stumble_day = 0;
var comment_url = "";
var comment_rating = -1; // rating button that is being used for commenting (0, 1)...

var prefetch_res = null;
var su_google_res = null;
var rate_res = null;
var unrate_res = null;
var recommend_res = null;
var g_recipient = "";

var stumbleid = 0;
var stumblepass;
var su_ratings; // array of url->su_ratings 

var su_loaded_data=0; // whether or not we have loaded the above arrays from disk
var stumbled_url; // your last stumble
var stumbled_urlid; // your last stumbleid
var stumbled_type; // your last stumble type
var rated_url; // your last rated url
var just_stumbled; // (we've just hit stumble .. and the page hasn't finished loading yet)
var su_old_url; // the last webpage your were on
var stumbles = new Array(); // queue of urls to be stumbled upon in the future
var user_interests; // array of intersts the user is signed up for
var su_catnames; // array of catid -> catname (topics.csv)
var su_catids; // array of catid -> catname (topics.csv)
var su_foldernames; // folder names
var topicfolders; // maps topic id's to su_foldernames

var su_OSName="Unknown OS";
if (navigator.userAgent.indexOf("Win")!=-1) su_OSName="Windows";
if (navigator.userAgent.indexOf("Mac")!=-1) su_OSName="MacOS";
if (navigator.userAgent.indexOf("Mac OS X")!=-1) su_OSName="MacOS X";
if (navigator.userAgent.indexOf("X11")!=-1) su_OSName="UNIX";
if (navigator.userAgent.indexOf("Linux")!=-1) su_OSName="Linux";

// Different OS's use different characters to delimit file paths
var su_SLASH = "/";

if (su_OSName=="Windows")
{
	su_SLASH = "\\";
}

if (su_OSName=="MacOS")
{
	su_SLASH = ":";
}

var su_du = new su_DirUtils(); // for reading mozilla directories
var su_prefDir = su_du.getPrefsDir() + su_SLASH; // for determining where the preference directory is, eg: ~/.DefaultUser/dsdfl23423s/

var su_fu = new su_FileUtils(); // for stating file, file.exists, stuff like that
var su_pr = new su_Prefs(); // for modifying pref.js, which is like a key->value type thing for storing small keys

function stumbleToggleToolbar()
{
	document.getElementById("stumbleupon").collapsed = !document.getElementById("stumbleupon").collapsed;
}

function su_load_categories()
{
	su_catnames = new Array();
	su_catids = new Array();
	topicfolders = new Array();
	su_foldernames = new Array();
	// Load topics.csv

	// okay, let's try topics.csv that came with the xpi
	var fname = "chrome://stumbleupon/content/topics.csv";
	
	var res = su_get_url(fname, '', '');
	var catdat = res.response;

	if (catdat == '')
	{
		fname = "chrome://stumbleupon/content/stumbleupon/topics.csv";
		res = su_get_url(fname, '', '');
		catdat = res.response;
	}

//!!! bah, let's not bother updating topics.csv over the net
// it changes so infrequently

/*
	alert(catdat);

 	var catdat = su_read_file_global("topics.csv");

	var da = new Date();
	var timenow = da.getTime();
	var oneweek = 24 * 60 * 60 * 7 * 1000; // javascript stores time in milliseconds

	var last_categories = su_pref_getstring_absolute("categories_dat");
	if (catdat == "" || timenow - last_categories > oneweek)
	{
		// We need to hit the server and grab topics.csv
		//!!! mozilla's caching is on crack (it doesn't even check server to see if there's a new vesrion unless we create a salt!)
		var res = su_get_url_server("topics.csv", su_useragent, "");
	
		// If we got it, make it catdat and write it to disk
		if (res.status == 200)
		{
 			catdat = res.response;
			su_write_file_global("topics.csv", catdat);
		}

		// Write last_categories
		last_categories = timenow;
		su_pref_setstring_absolute("categories_dat", timenow);
		su_pr.save();
	}

*/


	// Parse it into an array
	var folder = '';
	var folders = new Array();
	var splitseen = catdat.split("\n");
	for (var i = 0; i < splitseen.length; i++)
	{
		if (splitseen[i] == "")
			continue;
		
		var line = splitseen[i];
		var lines = line.split(",");
		var num = parseInt(lines[0]);
		var name = lines[1];
		if (typeof(lines[2]) != "undefined" && lines[2] != '')
		{		
			folder = lines[2];
			topicfolders[num] = folder;
			folders[folder] = 1;
		}
		su_catnames[num] = name;
		su_catids[name] = num;
	}

	var counter = 0;
	for (var key in folders)
	{
		su_foldernames[counter] = key;
		counter++;
	}

	su_foldernames.sort();
}

function set_stumbles(b_stumble, g_stumble)
{
	bad_stumble = b_stumble; 
	great_stumble = g_stumble;
}

// This function loads a bunch of arrays (like stumbleurls) 
//!!! we should probably put most of this into pref.js using the Pref object

function su_load_data1()
{
	// Initialize variables
	su_ratings = new Array();

	user_interests = new Array();

	stumbled_url = "";
	stumbled_urlid = 0;
	stumbled_type = 0;
	rated_url = "";
	just_stumbled = false;
	su_old_url = "";
	stumbles = new Array();

	su_pref_getorsetbool('comment_firstrating', true);
	su_pref_getorsetbool('review_new_window', false);
	su_pref_getorsetbool('stumble_topics', false);

	// make random delay...
	// this is to avoid a race condition in hitting stumbles.php
	// after X+su_random_delay seconds ... ( up to 5 minutes)
	su_random_delay = Math.floor(Math.random()*300);

	// load ratings
	var stumblecat = su_read_file_user("stumblerating");
	var splitcat = stumblecat.split("\n");
	for (i = 0; i < splitcat.length; i++)
	{
		if (splitcat[i] == "")
			continue;
		var split2 = splitcat[i].split(" ");
		su_ratings[split2[0]] = split2[1];
	}


	// Load stumbleurls (queue of urls to be stumbled upon)
	var stumbleseen = su_read_file_user("stumbleurls");
	if (stumbleseen != "")
	{
		var splitseen = stumbleseen.split("\n");
		
		for (i = 0; i < splitseen.length; i++)
		{
			if (splitseen[i] == "")
				continue;
			stumbles.push(splitseen[i]);
		}
	}

	// make sure last_uploaded,stumblestats,stumbletimes are set
	if (su_pref_getstring("last_uploaded") == false)
		su_pref_setstring("last_uploaded", 0);

	if (su_pref_getstring("stumbletypes") == false 
		&& su_pref_getstring("stumblestats") != false
		&& su_pref_getstring("stumblestats") != "")
	{
		// This is to grandfather in old clients, we need to populate types with 0
		var stumblestats = su_pref_getstring("stumblestats", "");

		var stumbletypes = "";
		var first = 0;
		splitseen = stumblestats.split(".");
		for (var i = 0; i < splitseen.length; i++)
		{
			if (first == 0)
				first = 1;
			else
				stumbletypes += ".";
			stumbletypes += "0";
		}
		su_pref_setstring("stumbletypes", stumbletypes);
	}
	else
	{
		if (su_pref_getstring("stumbletypes") == false)
		{
			su_pref_setstring("stumbletypes", "");
		}
	}

	if (su_pref_getstring("stumblestats") == false)
		su_pref_setstring("stumblestats", "");

	if (su_pref_getstring("stumbletimes") == false)
		su_pref_setstring("stumbletimes", "");

	var v_prefetch = su_pref_getorsetbool("prefetch", true);

	// Make sure we have defaults for seconds...
	bad_stumble = su_pref_getorsetbool("bad_stumble", false);

	// Make sure we have defaults for seconds...
	great_stumble = su_pref_getorsetbool("great_stumble", false);


	// Reset the useragent of pre-1.9996 clients.
	if (su_pr.getChar("general.useragent.vendorSub").indexOf("StumbleUpon") != -1)
	{
		su_pr.clear("general.useragent.vendorSub");
	}

	su_pr.save();

	// make sure we have cookies allowed for stumbleupon.com
	// or stumble won't work!
	var permMan = Components.classes["@mozilla.org/permissionmanager;1"].getService()
			  .QueryInterface(Components.interfaces.nsIPermissionManager);

	if(permMan != null)
	{
		var DocURI = Components.Constructor('@mozilla.org/network/standard-url;1', 'nsIURI');
		var stumbleURI = new DocURI;
		stumbleURI.spec = "stumbleupon.com";
		var action = permMan.ALLOW_ACTION;

		// make sure cookies work
		permMan.add(stumbleURI, "cookie", action);

		// also, make sure they can install so they can upgrade
		permMan.add(stumbleURI, "install", action);
	}

}

// This is the gui specific su_load_data
function su_load_data2(force_update)
{
	// make sure we have a nickname
	var nick = su_pref_getorsetstring("nick", "");

	// Make sure we have defaults for icons
	var icons_only = su_pref_getorsetstring("icons", "text-icons");
	su_show_icons(icons_only);

	// show rating buttons, menu, etc...
	document.getElementById("su_separator").hidden=false;
	document.getElementById("su_separator2").hidden=false;
	document.getElementById("su_separator4").hidden=false;
	document.getElementById("su_thumbdown").hidden=false;
	document.getElementById("su_thumbup").hidden=false;
	document.getElementById("stumble-menu").hidden=false;
	document.getElementById("stumble-menu").disabled=false;

	if (su_pref_getorsetbool("show_topics", true))
		document.getElementById("su_category").hidden=false;
	else
		document.getElementById("su_category").hidden=true;
	
	if (su_pref_getorsetbool("show_info", true))
		document.getElementById("su_website-info").hidden=false;
	else
		document.getElementById("su_website-info").hidden=true;

	if (su_pref_getorsetbool("show_mystumblers", false))
		document.getElementById("su_home").hidden=false;
	else
		document.getElementById("su_home").hidden=true;

	if (su_pref_getorsetbool("show_home", true))
		document.getElementById("su_profile").hidden=false;
	else
		document.getElementById("su_profile").hidden=true;

	if (su_pref_getorsetbool("show_messages", false))
		document.getElementById("su_messages").hidden=false;
	else
		document.getElementById("su_messages").hidden=true;

	if (su_pref_getorsetbool("show_referral", true))
		document.getElementById("su_referral-menu").hidden=false;
	else
		document.getElementById("su_referral-menu").hidden=true;

	if (su_pref_getorsetbool("show_friends", true))
		document.getElementById("su_friends").hidden=false;
	else
		document.getElementById("su_friends").hidden=true;

	if (su_pref_getorsetbool("show_matches", false))
		document.getElementById("su_matches").hidden=false;
	else
		document.getElementById("su_matches").hidden=true;

	if (su_pref_getorsetbool("show_aboutme", false))
		document.getElementById("su_aboutme").hidden=false;
	else
		document.getElementById("su_aboutme").hidden=true;

	if (su_pref_getorsetbool("show_groups", false))
		document.getElementById("su_groups").hidden=false;
	else
		document.getElementById("su_groups").hidden=true;

	if (su_pref_getorsetbool("show_editinfo", false))
		document.getElementById("su_editinfo").hidden=false;
	else
		document.getElementById("su_editinfo").hidden=true;

	if (su_pref_getorsetbool("show_forums", false))
		document.getElementById("su_forum").hidden=false;
	else
		document.getElementById("su_forum").hidden=true;

	// Make sure "Stumble On Browser Startup" is activated
	var stumble_homepage = su_pref_getbool("homepage");
	document.getElementById("su_makehomepage").setAttribute("checked", stumble_homepage);

	su_load_categories();

	// Load user_interests
	var stumbleseen = su_pref_getstring("interests");
	var splitseen = stumbleseen.split(" ");
	for (i = 0; i < splitseen.length; i++)
	{
		if (splitseen[i] == "")
			continue;
		user_interests[splitseen[i]] = 1;
	}
	update_interests();

	// Fill in email menu
	var emails = su_pref_getstring("emails");	

	// split it and then alphebetize them
	var incat;
	if (emails != "" && emails != 0 && emails != false && typeof(emails) != "undefined")
	{
		var semails = emails.split("\t");
		semails.sort();
		incat = document.getElementById("su_mail-menu");
		for (var i = 0; i < semails.length; i++)
		{
			var recipient_email = semails[i];
			if (recipient_email == "" || !su_checkemail(recipient_email))
				continue;
			var ja = document.createElement("menuitem");
			ja.setAttribute("label", recipient_email);

			ja.setAttribute("oncommand", "mailit(\"" + recipient_email + "\");");
			incat.childNodes[0].appendChild(ja);
		}
	}

	// fill up referral menu
	su_pref_getorsetstring("friends", "FRIEND");
	su_pref_getorsetstring("friends", "FIRSTFRIEND")
	su_pref_getorsetbool("sponsor", false);
	update_referral_menu();

/*
	if (stumble_homepage && getBrowser().contentDocument.location.toString() == "about:blank")
		stumble(0);
*/

	var newmessage = su_pref_getorsetbool("newmessage", false);
	if (newmessage)
		update_message_status('2');

	// save referral count
	var referral_count = parseInt(su_pref_getorsetstring("referral_count", '0'));

	// if referral count > 0, show the su_inbox-count and set it
	if (referral_count > 0)
	{
		document.getElementById("su_inbox-count").hidden=false;
		document.getElementById("su_inbox-count").value=referral_count;
 	}
	else
	{
		document.getElementById("su_inbox-count").hidden=true;
	}

	// Check to see if we've looked for referrals in the last 8 hours
	var check_referral = su_pref_getorsetstring("check-referral", 0);
	var last_stumbled = su_pref_getorsetstring("last_stumble", 0);
	
	var da = new Date();
	var timenow = da.getTime();
	var halfday = 8 * 60 * 60 * 1000; // javascript stores time in milliseconds
	var oneweek = 7 * 24 * 60 * 60 * 1000; // javascript stores time in milliseconds

	// don't keep do this if they aren't stumbling
	if (force_update == 1 || (timenow - check_referral > halfday && timenow - last_stumbled < oneweek))
	{
		// we need to hit recommend to check for new referrals
		recommend_callback = function(arg) {null_function_recommend(arg);};
		update_url_cache(0, 1);

		su_pref_setstring("check-referral", timenow);
	}

	// Store this stumbleid in the ids list.  The list is ordered from most recently 
	// used to least recently used.
	var id_list = su_pref_getstring_absolute("ids");
	
	var splitids = id_list.split(":");
	var foundit = 0;
	var id_list_new = stumbleid + ":";
	for (i = 0; i < splitids.length; i++)
	{
		if (splitids[i] == "")
			continue;
		
		var line = splitids[i];
		if (line != stumbleid)
		{
			id_list_new += splitids[i] + ":";
		}
	}
	su_pref_setstring_absolute("ids", id_list_new);

	su_pr.save();

	if ((navigator.userAgent.indexOf("Win") != -1) && 
				(navigator.userAgent.indexOf("Firefox") != -1))
	{
		// !!! The plugin only works on Firefox under XP for now....
		// See also https://bugzilla.mozilla.org/show_bug.cgi?id=123315
		
		if (su_pref_getorsetbool("search_plugin", true))
		{
			su_add_search_plugin();
		}
		else
		{
			su_remove_search_plugin();
		}
	}
}


function su_add_search_plugin()
{
	var dir = su_du.getSearchPluginsDir();
	
	// copy things over...
	if (dir != null)
	{
		dir += su_SLASH;
		
		var fname = "chrome://stumbleupon/content/stumbleupon.src";
		var res = su_get_url(fname, '', '');
		var towrite = res.response;

		if (towrite != '')
		{	
			su_write_file(dir + "stumbleupon.src", towrite);
	
			var persistAPI = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
			persistAPI.persistFlags = persistAPI.PERSIST_FLAGS_BYPASS_CACHE = 2;
			var docURI = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
			docURI.spec = "chrome://stumbleupon/content/skin/stumble.png";
			var tempLocalFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			tempLocalFile.initWithPath(dir + "stumbleupon.png");

			//!!! we  maybe be able to use this function to do more sophisticated
			// downloads that xmlhttprequest...(without the sync issue??)
			persistAPI.saveURI(docURI, null, null, null, null, tempLocalFile);
		}
	}
}

function su_remove_search_plugin()
{

	var dir = su_du.getSearchPluginsDir();
	
	if (dir != null)
	{
		dir += su_SLASH;
		
		var file = new su_File(dir + "stumbleupon.src");
		
		if (file.exists())
		{
			file.remove();
		}
		
		file = new su_File(dir + "stumbleupon.png");
		if (file.exists())
		{
			file.remove();
		}
	}
}


function null_function_recommend(error)
{
	// do nothing
}

var downloadProgressListener = {
	onLocationChange : function(aWebProgress, aRequest, aLocation)
	{
//		alert('new ' + aLocation.spec);
		var domWindow = aWebProgress.DOMWindow;
	
		// Update urlbar only if a new page was loaded on the primary content area
		// this helps us weed out frames loading...
		//!!! do we need to make this function async in case it fails???
 		if (domWindow == domWindow.top && aLocation != null) 
		{
//			alert('yep');
			su_on_new_page(aLocation.spec);
		}
	},

	onProgressChange : function (aWebProgress, aRequest,
			       aCurSelfProgress, aMaxSelfProgress,
			       aCurTotalProgress, aMaxTotalProgress)
 	{},

	onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus)
	{},

	onLinkIconAvailable : function(aBrowser, aHref)
	{},

	onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage)
	{},

	onSecurityChange : function(aWebProgress, aRequest, aState)
	{}
};

function su_load_it()
{
	// we use this function until we detect that there is more than 1 tab open
	// then we need to use the progress listener to detect
	// if they are switching between tabs
	su_new_topics();
	su_check_google();
	su_on_new_page(getBrowser().contentDocument.location.toString());
	su_check_progress_listener();
}

function su_check_progress_listener()
{
	window.removeEventListener("load", su_load_it, true);
	getBrowser().removeProgressListener(downloadProgressListener, Components.interfaces.nsIWebProgress.NOTIFY_LOCATION);

	if (getBrowser().browsers.length > 1)
		su_switched_listeners = 1;

	if (su_switched_listeners == 1)
	{
		// We need this listener if we have tabs open
		getBrowser().addProgressListener(downloadProgressListener);

		// for instances where we still need a load listener ( such as interests_after.php)
		window.addEventListener("load", su_load_it2, true);
	}
	else
	{
		window.addEventListener("load", su_load_it, true);
	}
}

function su_load_it2()
{
	// load listener when we have tabs open
	su_new_topics();
	su_check_google();
}

function su_check_google()
{
	// only beta testers get to use this
	if (	   stumbleid != 1 // geoff
		&& stumbleid != 2 // justin
		&& stumbleid != 8903 // conradaroma
		&& stumbleid != 25 // hifizen
		&& stumbleid != 5263 // rcamp
		&& stumbleid != 63815 // cloudhopper
		&& stumbleid != 74208 // joewalp
		&& stumbleid != 17856 // lope
		&& stumbleid != 16446 // khizeus
		&& stumbleid != 96247 // samantha
		&& stumbleid != 113014 // d-man
		&& stumbleid != 114243 // robtiki
		)
	{
		// no google for you
		return;
	}

	var new_url = getBrowser().contentDocument.location.toString();

	// Check to see if this url is google 
	var spliturl = new_url.split("/");
	var newtld = '';
	for (var i = 2; i < spliturl.length && i < 3 ; i++)
	{
		newtld += spliturl[i];
		if (i != 2)
			newtld += "/";
	}
	var tlds = newtld.split(".");
	if (tlds[0] == 'www' && tlds[1] == 'google' 
		&& (tlds.length==3 || (tlds.length==4 && tlds[2] == 'co' && tlds[3].length==2)))
	{
		// this should cover stuff like www.google.ca and www.google.co.jp
		// with a minimal of fall positives
		// false positive would have to be:
		// either www.google.X? or www.google.co.XX domain where google doesn't own it
		// make sure we are on a search results pages...
		if (spliturl.length==4 && spliturl[3].substr(0,7) == 'search?')
		{
			// first thing we need to do is see if we've already been here
			// the reason we could have already got a load event is:
			// 1. load google in a tab, we add review links
			// 2. go to another tab, start loading another page
			// 3. go back to other tab before loading finishes, we get a load event but with
			// the google url instead.  presumably there is some way to get the real url for the load event	
			// but don't know how at the moment, so here is a little hack:

			if (getBrowser().contentDocument.getElementsByTagName('body')[0].getAttribute('alreadydone') != 'alreadydone')
			{
				getBrowser().contentDocument.getElementsByTagName('body')[0].setAttribute('alreadydone', 'alreadydone');		

				// okay, now look for first 10 results (we'll only do 10)
				var links = getBrowser().contentDocument.getElementsByTagName('a');
				var counter = 0;
				su_google_links = new Array();
				for (i = 0; i < links.length; i++)
				{
					if (counter > 10)
						break;
					thelink = links[i];
					var url = thelink.href;
					if (url.indexOf('http://') == 0) 
					{
						var element = thelink.parentNode;
						if (element.getAttribute('class')=='g')
						{
							//!!! we should substr these urls to 255 since we're going to substr them later anyway
							su_google_links.push(url);
							counter++;
						}
					}
				}
				// create a query
				var query = '';
				var first = 0;
				for (i = 0; i < su_google_links.length; i++)
				{
					if (first == 0)
						first = 1;
					else
						query += '%09';
					query += escape(su_google_links[i]);
				}
				//alert(query);
				su_google_res = su_get_url_server_async('urls.php?username=' + stumbleid + '&password=' + escape(stumblepass) + '&u=' + query, su_useragent, "", su_google_done);
			}
			else
			{
				// alert("already done");
			}
		}
	}
}

function su_google_done()
{
	var res = su_google_res;

	if (res.status != 200)
		return 0;

	//!!! we should confirm we're still on the same page...

	// ok, now parse the result	
	var s = res.responseText;
	// Split the response it username and pass

	var ss;
	if (typeof(s) == "undefined")
		s = "";

	ss = s.split("\n");

	// go through urls, see if we need to rewrite them
	var new_url = getBrowser().contentDocument.location.toString();

	// Check to see if this url is google 
	var spliturl = new_url.split("/");
	var newtld = '';
	for (var i = 2; i < spliturl.length && i < 3 ; i++)
	{
		newtld += spliturl[i];
		if (i != 2)
			newtld += "/";
	}
	var tlds = newtld.split(".");
	if (tlds[0] == 'www' && tlds[1] == 'google' 
		&& (tlds.length==3 || (tlds.length==4 && tlds[2] == 'co' && tlds[3].length==2)))
	{
		if (spliturl.length==4 && spliturl[3].substr(0,7) == 'search?')
		{
			// okay, now look for first 10 results (we'll only do 10)
			// i = 0;
			var links = getBrowser().contentDocument.getElementsByTagName('a');
			var counter = 0;
			for (i = 0; i < links.length; i++)
			{
				if (counter > 10)
					break;
				var thelink = links[i];
				var url = thelink.href;
				if (url.indexOf('http://') == 0) 
				{
					var element = thelink.parentNode;
					if (element.getAttribute('class')=='g')
					{
						// check ss[counter] for an url
						if (ss.length > counter && ss[counter].split("\t").length == 2)
						{
							// we got some info
							comments = ss[counter].split("\t")[1];
							var linka = getBrowser().contentDocument.createElement("span");
							var url2 = su_review_url(url);
							var html = ' <a href="http://www.stumbleupon.com/url/' + url2 + '"><img border=0 src="chrome://stumbleupon/content/skin/stumble.png"></a> <a class=f1 style="color:#7777cc;" href="http://www.stumbleupon.com/url/' + url2 + '"><font size=2>';
							if (comments != 0)
								html += '<font color=#ff0000>' + comments + '</font>';
							html += ' review';
							if (comments != 1)
								html += 's';
							html += '</font></a>';
							linka.innerHTML = html;
							element.insertBefore(linka, element.childNodes[2]);
						}
						
						//!!! we should substr these urls to 255 since we're going to substr them later anyway
						counter++;
					}
				}
			}
		}
	}

	return 0;
}

function su_new_topics()
{
	var new_url = getBrowser().contentDocument.location.toString()

	// Check to see if this url is intersts_after (if it is we need to grab the new interests)
	if (new_url == su_serverhttp + "interests_after.php")
	{
		// Grab the comment
		var blah = getBrowser().contentDocument.getElementById("interests");
		var blah2 = blah.innerHTML;
		var blah3 = blah2.split("|");
		var blah4 = blah3[1];
		blah5 = blah4.split(" ");
		user_interests = new Array();
		for (var i = 0; i < blah5.length; i++)
		{
			if (blah5[i] != "")
				user_interests[blah5[i]] = 1;
		}
		update_interests();

		//!!! clear stumble urls (so we start getting new sites right away
		clear_stumbles();
	}
}


function su_handle_gui_load()
{
	su_load_data2(0);

	// hook up some rating button action
	su_on_new_page(getBrowser().contentDocument.location.toString());

	// Check to see when the url changes
	window.addEventListener("load", su_load_it, true);

	// Check stuff stuff once a minute
	su_changeInterval = setInterval("su_oneMinute()", 300000);
}


//************** END INITIALIZATION ****************/


//************** UTILITY FUNCTIONS *****************/


function is_adult(cat)
{
	if (is_porn(cat) || cat == 179 || cat == 173 || cat == 50
		|| cat == 391 || cat == 159 || cat == 279 || cat == 351)
	{
		return 1;
	}
	else
	{
	    	return 0;
	}
}

function is_porn(cat)
{
	// Determines if a category is porn
 	if (cat == 6 || cat == 193 || (cat >= 500 && cat < 600))
 		return 1;
	else
		return 0;
}

function is_image(url)
{
	// checks to see if url is an image or a movie
	var last3 = url.substr(url.length-3).toLowerCase();
	var last4 = url.substr(url.length-4).toLowerCase();
	var last5 = url.substr(url.length-5).toLowerCase();
	if (    last3 == ".qt" || last3 == ".ra" || last3 == ".rm"
		|| last4 == ".gif" || last4 == ".jpg" || last4 == ".png"
  		|| last4 == ".avi" || last4 == ".asf" || last4 == ".mpg"
   		|| last4 == ".wmf" || last4 == ".wmv" || last4 == ".wma"
		|| last4 == ".wav" || last4 == ".mov" || last4 == ".mp3"
		|| last4 == ".ram"
		 || last5 == ".jpeg" || last5 == ".mpeg")
	{
		return 1;
	}
	else
	{
		return 0;
	}
}


//************** END UTILITY FUNCTIONS ***************/


//******** FILE FUNCTIONS **********//

function su_write_file_user(fname, data)
{
	return su_write_file(su_prefDir + fname + stumbleid, data);
}

function su_write_file_global(fname, data)
{
	return su_write_file(su_prefDir + fname, data);
}

function su_write_file(fname, data)
{
	if (data == "")
	{
		// remove the file and quit (we can't write "")
		try { su_fu.remove(fname); }
		catch (e) { }
		return;
	}
	var file = new su_File(fname);

	try { file.open("w"); }
	catch (e) { } 

	try { file.write(data); }
	catch (e) { } 

	file.close();
}

function su_read_file_user(fname)
{
	return su_read_file(su_prefDir + fname + stumbleid);
}

function su_read_file_global(fname)
{
	return su_read_file(su_prefDir + fname);
}

function su_read_file(fname)
{
	var file = new su_File(fname);

	try { file.open("r"); }
	catch (e) { } 

	try { var s  = file.read(); }
	catch (e) { } 
	if (typeof(s) == "undefined" || s == null)
		s = "";
	file.close();
	return s;
}

function append_file_user(fname, data)
{
	try {
		var x = new su_File(su_prefDir + stumbleid + su_SLASH + fname);
		if (x.exists()) 
			x.open("a", 0644);
		else
			x.open("w", 0644);

		if (!x.write(data, 0644)) 
		{
			su_jslibError(null, "Could not appened data to file", "NS_ERROR_UNEXPECTED", "append_file");
			return false;
		}
		x.close();	
		return true;
	} catch(e) {
		su_jslibError(e, "Could not appened data to file", "NS_ERROR_UNEXPECTED", "append_file_user"); 
		return false;
	}
}

/*
function append_file(fname, data)
{
	// Append mode is currently totally screwed in mozilla, for now we
	// do it the long way  ...read in the file, add, then overwrite ;-(
	var s = su_read_file(fname, data);
	s += data;
	su_write_file(fname, s);
}
*/

//***************** END FILE FUNCTIONS ******************//


//***************** GUI HANDLERS ************************//

// deals with interests if you select it from the menu item add more interests...
function interests_pre()
{
	su_interests();
	document.getElementById("su_category").selectedIndex = 0;
	document.getElementById("su_category").label = "All";
}

function select_topic(topic,label)
{
	document.getElementById("su_category").selectedIndex=topic;
	document.getElementById("su_category").label=label;
	stumble(0);
}

// Updates interest list in the in-cat stumble dialog, and saves current interests to disk (user_interests)
function update_interests()
{
	var incat = document.getElementById("su_category");

	// Nuke all the children and then add them from user_interests
	var children = incat.childNodes[0].childNodes;
	for (var i = 0; i < children.length; i++)
		incat.childNodes[0].removeChild(children[i]);

	// This is the javascript way of creating an object and it's constructor:
	function CatObj (id, name) {this.id = id;  this.name = name;}
	
	// This sorts CatObjs alphabetically by name
	function compareCats(a, b) 
	{
		if ( a.name < b.name ) return -1;
		if ( a.name > b.name ) return 1;
		return 0;
	}

	su_load_categories();

	// Now add new children
	var ints = new Array();
	for (var cat in user_interests)
	{
		if (typeof(su_catnames[cat]) != "undefined")
			ints.push(new CatObj(cat, su_catnames[cat]));
	}

	ints.sort(compareCats);

	var ja = document.createElement("menuitem");
	ja.setAttribute("class", "topic-selector");
	ja.setAttribute("label", su_bundle.GetStringFromName("menu.anytopic"));
	ja.setAttribute("label", "All");
	ja.setAttribute("id", "0");
	ja.setAttribute("oncommand", "select_topic(0,'All');");
	incat.childNodes[0].appendChild(ja);

	// Create favorites of menu
	ja = document.createElement("menu");
	ja.setAttribute("class", "topic-selector");
	ja.setAttribute("label", "Favorites of");
	ja.setAttribute("tooltiptext", "Mutual Friends' Sites");
	ja.setAttribute("id", "favorites_of");
	var friends = incat.childNodes[0].appendChild(ja);

	ja = document.createElement("menupopup");
	ja.setAttribute("class", "topic-selector");
	ja.setAttribute("id", "friends-popup");
	var last_node = friends.appendChild(ja);

/*
	ja = document.createElement("menuitem");
	ja.setAttribute("class", "topic-selector");
	ja.setAttribute("label", su_bundle.GetStringFromName("menu.mynews"));
	ja.setAttribute("label", "News");
	ja.setAttribute("id", "news");
	ja.setAttribute("oncommand", "select_topic('news', 'News');");
	incat.childNodes[0].appendChild(ja);
*/
	ja = document.createElement("menuseparator");
	incat.childNodes[0].appendChild(ja);

	if (ints.length < 21)
	{
		for (i = 0; i < ints.length; i++)
		{
			ja = document.createElement("menuitem");
			ja.setAttribute("class", "topic-selector");
			ja.setAttribute("label", ints[i].name);
			ja.setAttribute("id", ints[i].id);
			var newname = ints[i].name.replace(/'/g, "\\\'");
			ja.setAttribute("oncommand", "select_topic(" + ints[i].id + ",'" + newname + "');");
			incat.childNodes[0].appendChild(ja);
		}
	}
	else
	{
		var folders = new Array();
		for (cat in user_interests)
		{
			var folder = topicfolders[cat];
			var name = su_catnames[cat];
			if (typeof(folders[folder]) == "undefined")
				folders[folder] = new Array();
		
			folders[folder][name]=cat;
		}
	
		for (i = 0; i < su_foldernames.length; i++)
		{
			var key = su_foldernames[i];
			if (typeof(folders[key]) == "undefined")
					continue;
			// topics = folders[key];

			ja = document.createElement("menu");
			ja.setAttribute("class", "topic-selector");
			ja.setAttribute("label", key);
			var child = incat.childNodes[0].appendChild(ja);
	
			ja = document.createElement("menupopup");
			ja.setAttribute("class", "topic-selector");
			var child2 = child.appendChild(ja);

			var newtopics = new Array();
			var counter = 0;
			for (var catname in folders[key])
			{
				newtopics[counter] = catname;
				counter++;	

			}
			newtopics.sort();
			for (var j = 0; j < newtopics.length; j++)
			{
				name = newtopics[j];
				var catid = su_catids[name];

				ja = document.createElement("menuitem");
				ja.setAttribute("class", "topic-selector");
				ja.setAttribute("label", name);
				ja.setAttribute("id", catid);
				newname = name.replace(/'/g, "\\\'");
				ja.setAttribute("oncommand", "select_topic(" + catid + ",'" + newname + "');");
				child2.appendChild(ja);
			}
		}
	}

	ja = document.createElement("menuseparator");
	incat.childNodes[0].appendChild(ja);

	ja = document.createElement("menuitem");
	ja.setAttribute("class", "topic-selector");
	ja.setAttribute("label", su_bundle.GetStringFromName("menu.addmoretopics"));
	ja.setAttribute("label", "Update Topics");
	ja.setAttribute("id", "addmore");
	ja.setAttribute("oncommand", "interests_pre();");
	incat.childNodes[0].appendChild(ja);

	// Sets default selected category to "any topic"
	incat.childNodes[0].activeChild = incat.childNodes[0].childNodes[0];
	incat.selectedIndex=0;
	incat.label='All';

	// now write it to disk
	var towrite = "";
	var first = 0;
	for (var ii in user_interests)
	{
		if (first == 0)
			first = 1;
		else
			towrite += " ";
		towrite += ii + " ";
	}
	su_pref_setstring("interests", towrite);

	// populate favorites of menu	
	update_favorites_of();
}

function update_favorites_of()
{
	if (document.getElementById("su_category").selectedIndex != 0)
		return;

	// first check to see if favorites of is already there
	var friends = document.getElementById("friends-popup");

	// clear the current friends menu
	var children = friends.childNodes;
	for (var i = 0; i < children.length; i++)
		friends.removeChild(children[i]);

	var num_friends = 0;
	// populate favorites of menu if they are a sponsor
	var parsed_friends = new Array();
	if (su_pref_getbool("sponsor"))
		parsed_friends = su_pref_getstring("friends").split(' ');
	else
		parsed_friends = su_pref_getstring("firstfriends").split(' ');

	for (i = 1; i < parsed_friends.length; i++)
	{
		num_friends++;
		var ja = document.createElement("menuitem");
		ja.setAttribute("label", parsed_friends[i]);
		ja.setAttribute("class", "topic-selector");
		ja.setAttribute("id", parsed_friends[i]);
		ja.setAttribute("oncommand", "select_topic('" + parsed_friends[i] + "', '" + parsed_friends[i] + "');");
		friends.appendChild(ja);
	}

	if (num_friends < 20)
	{
		// Add invite friends link if they have less than 20 mutual friends
		ja = document.createElement("menuseparator");
		friends.appendChild(ja);

		// If they are not a sponsor, and they have 5 mutual friends,
		// they can't add any more, so we should show them how to upgrade
		ja = document.createElement("menuitem");
		ja.setAttribute("class", "topic-selector");
		if (num_friends == 5 && !su_pref_getbool("sponsor"))
		{
			// They are maxxed on out friends
			ja.setAttribute("label", "Upgrade Now");
			ja.setAttribute("oncommand", "su_sponsor('&addmutual=1');");
		}
		else
		{
			ja.setAttribute("label", "Invite Friend");
			ja.setAttribute("oncommand", "su_invite(1);");
		}

		friends.appendChild(ja);
	}
}

// Handler for menuitem "Report Spam"
function spam()
{
	if (stumbled_url == "")
	{
		alert("You can't report pages that you haven't Stumbled upon."); 
		return;
	}

	// grab the current HTML window
	var doc = getBrowser().contentDocument;

	if (stumbleid == 0)
		return;

	// Redirect to the spam page
	if (doc.location != stumbled_url)
		doc.location = stumbled_url;
	
	if (window.confirm("Are you sure the following URL is spam?\n\n" + stumbled_url))
		doc.location = su_base_url + "spam.php?username=" + stumbleid + "&password=" + escape(stumblepass) + "&url=" + stumbled_url;
}

// Handler for menuitem "Report 404"
function report_404()
{
	if (stumbled_url == "")
	{
		alert("You can't report pages that you haven't Stumbled upon."); 
		return;
	}

	// grab the current HTML window
	var doc = getBrowser().contentDocument;

	if (stumbleid == 0)
		return;

	// Redirect to the spam page
	if (doc.location.toString() != stumbled_url)
		doc.location = stumbled_url;
	
	//!!! we shouldn't really report 404, it should be something else (user 404?)
	if (window.confirm("Are you sure the following URL is 404?\n\n" + stumbled_url))
	{
		su_get_url_server_async('404.php?url=' + escape(stumbled_url) + "&version=" + su_verstring + "&status=404", su_useragent, "", null_function);
		alert("404 reported for page:\n\n" + stumbled_url);
	}
}

// Handler for menuitem "Change Current User"
function su_change_user()
{
	var signinWindow = "chrome://stumbleupon/content/signinDialog.xul";
	window.openDialog(signinWindow, "Sign-In", "chrome,modal,dialog,centerscreen,dependent");
}

// Handler for menuitem "Change Password"
function su_change_password()
{
	var password = getBrowser().contentWindow.prompt("Please enter a new StumbleUpon password","");

	// they clicked cancel
	if (typeof(password) == "undefined")
		return false;

	while (password.length > 16)
	{
		alert("Password cannot be longer than 16 characters");
		password = getBrowser().contentWindow.prompt("Please enter a new StumbleUpon password","");
	}

	if (password > "")
	{
		var res = su_get_url_server('changepassword.php?version=' + su_verstring + "&username=" + stumbleid + "&password=" + escape(stumblepass) + "&newpassword=" + escape(password), su_useragent, "");
		if (res.status == 1)
			return false;
	
		if (res.status != 200)
		{
			alert("The stumbleupon.com server is currently down.\nPlease try again, and if you are still having difficulties,\ngo to http://www.stumbleupon.com/feedback.php to report the problem\nError : " + res.error + "\nStatus : " + res.status);
			return false;
		}

		var s = res.response;

		// Split the response it username and pass
		var ss;
		if (typeof(s) == "undefined")
		{
			s = "";
			ss = s.split("\n")[0].split(" ");
		}
		else
		{
			ss = new Array();
			ss[0] = "";
		}

		if (ss[0] == "ERROR")
  		{
			alert("There was an error changing your password : " + s);
		}
		else
		{
			// change local password
			su_pref_setstring("password", password);
			su_pr.save();
			stumblepass = password;
			alert("Password changed");

			// we hit stumblers so they get the new password session cookie
			stumblers(0);
		}
		return true;
	}
	else if (password == "")
	{
		alert("You cannot have a blank password!");
		return false;
	}
	else
	{
		// cancel...
		return false;
	}

	return true;
}

// Handler for menuitem "Feedback"
function su_feedback()
{
	if (stumbleid == 0)
		return false;

	// Redirect to the feedback page
	var current_page = getBrowser().contentDocument.location.toString();
	getBrowser().contentDocument.location = su_base_url + "feedback.php?username=" + stumbleid + "&password=" + escape(stumblepass) + "&version=" + su_verstring;

	return true;
}

// Handler for menuitem "Logout"
function su_logout()
{
	var doc = getBrowser().contentDocument;

	if (stumbleid == 0)
		return false;

	if (window.confirm("Are you *sure* you would like to Sign-out?\n\n(Click CANCEL if you do not know your password,\nor you will LOSE THIS ACCOUNT)"))
	{
		// 1. remove username and password (!!! should we delete all the keys?)
		su_pref_setstring_absolute("current_user", '');
		su_pref_setstring("password", '');
		
		// now sync this stuff before we crash
		su_pr.save();

		// 2. change current user to 0
		stumbleid = 0;
		stumblepass = '';

		// 3. remove cookies stumble_user, stumble_pass, and PHPSESSID
		// ??? or maybe just all cookies from stumbleupon.com?

		var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
		cookieManager.remove("." + su_servername, "PHPSESSID", "/", 0);
		cookieManager.remove("." + su_servername, "stumble_user", "/", 0);
		cookieManager.remove("." + su_servername, "stumble_pass", "/", 0);
		
		// 4. Okay, now return the toolbar to its virgin state
		document.getElementById("su_separator").hidden=true;
		document.getElementById("su_separator2").hidden=true;
		document.getElementById("su_separator4").hidden=true;
		document.getElementById("su_thumbdown").hidden=true;
		document.getElementById("su_thumbup").hidden=true;
//		document.getElementById("stumble-menu").hidden=true;
		document.getElementById("stumble-menu").disabled=true;
		document.getElementById("su_category").hidden=true;
		document.getElementById("su_website-info").hidden=true;	
		document.getElementById("su_home").hidden=true;	
		document.getElementById("su_profile").hidden=true;	
		document.getElementById("su_messages").hidden=true;	
		document.getElementById("su_friends").hidden=true;	
		document.getElementById("su_aboutme").hidden=true;	
		document.getElementById("su_matches").hidden=true;	
		document.getElementById("su_groups").hidden=true;	
		document.getElementById("su_editinfo").hidden=true;
		document.getElementById("su_forum").hidden=true;
		document.getElementById("su_referral-menu").hidden=true;
		document.getElementById("su_inbox-count").hidden=true;

		document.getElementById("firstrater").hidden=true;
		document.getElementById("su_stumble_topic").hidden=true;
		document.getElementById("su_sponsor").hidden=true;

		document.getElementById("stumble").label=document.getElementById("stumble").getAttribute('firstlabel');
	}

	return true;
}


// Handler for menuitem "Chatroom"
function su_chat()
{
	var doc = getBrowser().contentDocument;

	if (stumbleid == 0)
		return;

	// See if this is an incat thingy
	var user_cat = document.getElementById("su_category").selectedIndex;

	// Redirect to the chat page
	var current_page = getBrowser().contentDocument.location.toString();
	getBrowser().contentDocument.location = su_base_url + "chat.php?username=" + stumbleid + "&password=" + escape(stumblepass) + "&category=" + user_cat;
}

// Handler for button "FirstRater" (the happy face)
function firstrater_func(event)
{
	var doc = getBrowser().contentDocument;

	if (stumbleid == 0)
		return;

	var frater = document.getElementById("firstrater");
	var firstrater = frater.firstrater;

	if (event.button == 0)
		auth_server_url_absolute("http://" + firstrater + "." + su_servername + "/", 0);
	if (event.button == 2 || event.button == 1)
		auth_server_url_absolute("http://" + firstrater + "." + su_servername + "/", 1);
}

// Redirects to the give "stumbleupon.com + session_url" while making sure
// username and password are set correctly for that url (and are session registered)
function session_redir(session_url, new_tab)
{
	var doc = getBrowser().contentDocument;

	var theurl = su_base_url + "session.php?username=" + stumbleid + "&password=" + escape(stumblepass) + "&session_url=" + escape(su_base_url + session_url);

	if (new_tab == 1)
		getBrowser().contentWindow.openNewTabWith(theurl);
	else
		getBrowser().contentDocument.location = theurl;
}

function session_redir_absolute(session_url, tab, middleclick)
{
	var nick = su_pref_getstring("nick");
	if (nick != '' && session_url == 'home')
	{
		// go straight to profile page using headers...
		var go_url = "http://" + nick + "." + su_servername + "/";
		if (tab != '')
			go_url += tab + "/";
		auth_server_url_absolute(go_url, middleclick);
	}
	else
	{	
		var theurl = su_base_url + "session.php?username=" + stumbleid + "&password=" + escape(stumblepass) + "&session_url=" + escape(session_url);
		if (tab != '')
			theurl += "&session_tab=" + tab;
		if (middleclick)
			window.openNewTabWith(theurl);
		else
			getBrowser().contentDocument.location = theurl;
	}
}

function auth_server_url(url, new_tab)
{
	auth_server_url_absolute(su_base_url + url, new_tab)
}

function auth_server_url_absolute(url, new_tab)
{
	var browser = getBrowser();
	var DocURI = Components.Constructor('@mozilla.org/network/standard-url;1', 'nsIURI');
	var referrerURI = new DocURI;
	referrerURI.spec = "";
//	var characterSet = browser.contentDocument.characterSet;

	const MIME_STREAM_CID = "@mozilla.org/network/mime-input-stream;1";
	const nsIMIMEInputStream = Components.interfaces.nsIMIMEInputStream;
	var mis = Components.classes[MIME_STREAM_CID];

	var headers = mis.createInstance(nsIMIMEInputStream);
	headers.addHeader('X-SU-Username', stumbleid);
	headers.addHeader('X-SU-Password', stumblepass + '\r\n');

	if (new_tab == 1)
	{
		var tab = browser.addTab("about:blank");
		browser.selectedTab = tab;
		browser.webNavigation.loadURI(url, 0, referrerURI, null, headers);
	}
	else
	{
		browser.webNavigation.loadURI(url, 0, referrerURI, null, headers);
	}
}

// Handler for button "Website Info"
function su_website_info(new_tab)
{
	var doc = getBrowser().contentDocument;

	if (su_pref_getbool("review_new_window"))
		new_tab = 1;

	if (stumbleid == 0)
		return;

	// Redirect to about page
	var quote = "";
	if (doc.getSelection)
		quote = doc.getSelection();

	var current_page = doc.location.toString();
	if (photoblogimage != "")
	{
		auth_server_url("url.php?url=" + escape(current_page) + "&image=" + escape(photoblogimage.src) + "&width=" + photoblogimage.width + "&height=" + photoblogimage.height, new_tab);
		photoblogimage = "";
	}
	else
	{
		if (quote != "")
		{
			auth_server_url("url.php?url=" + escape(current_page) + "&quote=" + escape(quote), new_tab);
		}
		else
		{
			var current_page2 = su_review_url(current_page);

			//!!! new_tab
			auth_server_url("url/" + current_page2, new_tab);
		}
	}
}

function su_review_url(current_page)
{
	// strip off the http://
	if (current_page.substr(0,7) == "http://")
		current_page = current_page.substr(7);
	var current_page2="";
	for (var j = 0; j < current_page.length; j++)
	{
		// double encode the ampserand...  
		if (current_page[j] == "?")
			current_page2+="%3F";
		else if (current_page[j] == "&")
			current_page2+="%2526";
		else
			current_page2+=current_page[j];	
	}
	return current_page2.replace(/%2F/g, "%252F");
}

// Check to see if an email is valid
function su_checkemail(str)
{
	// var filter=/^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;
	var filter  = /^([a-zA-Z0-9_\.\-+])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
	if (filter.test(str))
		return(true);
	else
		return(false);
}

// Handler for menuitem from mailto menu
function mailit(recipient_email)
{
	if (stumbleid == 0)
		return;

	// First check to make sure they've entered their email address
	var sender_email = su_pref_getstring("sender_email");
	if (sender_email == "")
	{
		// Fire up a dialog box
		sender_email = getBrowser().contentWindow.prompt("Please enter *your* email address","");
		if (sender_email == "" || typeof(sender_email) == "undefined")
			return;
		// do an email sanity check
		if (!su_checkemail(sender_email))
		{
			alert("That is not a valid email address!");
			return;
		}
		su_pref_setstring("sender_email", sender_email);
		su_pr.save();
	}

	// Now grab recipient and cache it
	if (recipient_email == "")
	{
		recipient_email = getBrowser().contentWindow.prompt("Please enter the recipient's email address", "");
		if (recipient_email == null || recipient_email == "" || typeof(recipient_email) == "undefined")
			return;
	}

	// do an email sanity check
	if (!su_checkemail(recipient_email))
	{
		alert("Recipient is not a valid email address!");
		return;
	}

	var url = getBrowser().contentDocument.location.toString();
	var thetitle = getBrowser().contentDocument.title;
	
	g_recipient = recipient_email;

	var note = getBrowser().contentWindow.prompt("Note to " + recipient_email + " about:\n\n" + url,"");
	if (typeof(note) == "undefined" || note == null)
		return;

	su_get_url_server_async('mailit.php?username=' + stumbleid + '&password=' + escape(stumblepass) + '&version=' + su_verstring + '&url=' + escape(url) + '&sender=' + escape(sender_email) + '&recipient=' + recipient_email + '&title=' + escape(thetitle) + '&note=' + escape(note), su_useragent, "", su_email_done);

	// Cache the email
	var emails = su_pref_getstring("emails");
	//!!! nuke dupes
	var seenit = 0;
	if (emails != "" && emails != 0 && typeof(emails) != "undefined")
	{
		var semails = emails.split("\t");
		for (var i = 0; i < semails.length; i++)
		{
			var remail = semails[i];
			if (recipient_email == remail)
			{
				seenit = 1;
				break;
			}
		}
	}
	if (seenit == 0)
	{
		emails += "\t" + recipient_email;
		su_pref_setstring("emails", emails);
		su_pr.save();
		// Add it to the menu immediately
		var incat = document.getElementById("su_mail-menu");
		var ja = document.createElement("menuitem");
		ja.setAttribute("label", recipient_email);
		ja.setAttribute("oncommand", "mailit(\"" + recipient_email + "\");");
		incat.childNodes[0].appendChild(ja);
	}
}

function su_email_done()
{
	alert("Email succesfully sent to : " + g_recipient); 
}

// Handler for menuitem to change email address
function su_change_email()
{
	if (stumbleid == 0)
		return;

	// Fire up a dialog box
	sender_email = getBrowser().contentWindow.prompt("Please enter *your* email address","");
	if (sender_email == "" || typeof(sender_email) == "undefined")
		return;
	// do an email sanity check
	if (!su_checkemail(sender_email))
	{
		alert("That is not a valid email address!");
		return;
	}
	su_pref_setstring("sender_email", sender_email);
	su_pr.save();
}

// Handler for menuitem "About"
function su_about()
{
	// Redirect to about page
	getBrowser().contentDocument.location = su_serverhttp + 'about.php?version=' + su_verstring;
}

// Migrate the user to the new profile format ( so we can have multiple users)
function su_migrate()
{
	// Migrate stumbleid
	var theid = su_read_file_global("stumbleid");

	var theids = theid.split("\n");
	stumbleid = theids[0];
	stumblepass = theids[1];
	if (typeof(stumblepass) == "undefined" || stumblepass == "" || stumblepass == "undefined" || stumblepass == null || !stumblepass)
		stumblepass = "a";

	//*** MIGRATE FILES

	// create directory
	var thedir = su_prefDir + stumbleid + su_SLASH;
	var d = new su_Dir(thedir);
	d.create(0700);

	// Migrate stumbleurls
	var out = su_read_file_global("stumbleurls");
	su_write_file_user("stumbleurls", out);
	var out2 = su_read_file_user("stumbleurls");

	// Migrate stumblerating
	out = su_read_file_global("stumblerating");
	su_write_file_user("stumblerating", out);

	// Migrate stumbleinterests
	out = su_read_file_global("stumbleinterests");
	su_write_file_user("stumbleinterests", out);

	//*** MIGRATE PREFS
	
	var str = su_pref_getstring_absolute("emails");
	str2="";
	// turn pipes to "\t" in a string
	for (j = 0; j < str.length; j++)
	{
		if (str[j] == "|")
			str2+="\t";
		else
			str2+=str[j];	
	}
	
	su_pref_setstring("emails", str2);
	var str3 = su_pref_getstring("emails");

	var thepref = su_pref_getstring_absolute("homepage");
	su_pref_setstring("homepage", thepref);

	thepref = su_pref_getstring_absolute("old_homepage");
	su_pref_setstring("old_homepage", thepref);

	thepref = su_pref_getstring_absolute("sender_email");
	su_pref_setstring("sender_email", thepref);

	// set current user
	su_pref_setstring_absolute("current_user", stumbleid);

	// save password
	su_pref_setstring("password", stumblepass);

	// now sync this stuff before we crash
	su_pr.save();

	//!!! Nuke the old prefs (we can't do this!!!)
	
	// Nuke the old files
	su_write_file_global("stumbleid", "");
	su_write_file_global("stumbleurls", "");
 	su_write_file_global("seenurls", "");
	su_write_file_global("stumblecat", "");
	su_write_file_global("stumbleinterests", "");
	su_write_file_global("stumblerating", "");
}

// Migrate the user to the new profile format without directories
function su_migrate2()
{
	// create directory
	var thedir = stumbleid + su_SLASH;

	// Migrate stumbleurls
	var out = su_read_file_global(thedir + "stumbleurls");
	su_write_file_user("stumbleurls", out);

	// Migrate stumblerating
	out = su_read_file_global(thedir + "stumblerating");
	su_write_file_user("stumblerating", out);

	// Migrate stumbleinterests
	out = '';
	var stumbleseen = su_read_file_global(thedir + "stumbleinterests");
	var splitseen = stumbleseen.split("\n");
	var first = 0;
	for (i = 0; i < splitseen.length; i++)
	{
		if (splitseen[i] == "")
			continue;
		if (first == 0)
			first = 1;
		else
			out += " ";
		out += splitseen[i];
	}

	su_pref_setstring("interests", out);

	// now sync this stuff before we crash
	su_pr.save();

	// Nuke the old files
	su_write_file_global(thedir + "stumbleurls", "");
	su_write_file_global(thedir + "stumbleinterests", "");
	su_write_file_global(thedir + "stumblerating", "");
}


// Hits get_interests since we don't already have them?
function get_interests()
{
	// Now hit getinterests.php to make sure we're not already signed up for something (like ACOR)
	var res = su_get_url_server('getinterests.php?&username=' + stumbleid + '&password=' + escape(stumblepass) + '&version=' + su_verstring, su_useragent, "");
	if (res.status == 1)
	{
		return false;
	}
	if (res.status != 200)
	{
		alert("The stumbleupon.com server is currently down.\nPlease try again, and if you are still having difficulties,\ngo to http://www.stumbleupon.com/feedback.php to report the problem\nError : " + res.error + "\nStatus : " + res.status);
		return false;
	}
	
	var s = res.response;

	// Split the response it username and pass
	if (typeof(s) != "object" && typeof(s) != "undefined" && s != "")
	{
		var blah5 = s.split(" ");
		user_interests = new Array();
		for (var i = 0; i < blah5.length; i++)
		{
			if (blah5[i] != "")
				user_interests[blah5[i]] = 1;
		}
	}
	update_interests();
	return true;
}

function su_http_error(error, status)
{
	alert("The stumbleupon.com server is currently down.\nPlease try again, and if you are still having difficulties,\ngo to http://www.stumbleupon.com/feedback.php to report the problem\nError : " 
		+ error + "\nStatus : " + status);
}

// This function grabs a new stumbleid from the server, generally just called once the first time a user hits "stumble"
function get_stumbleid()
{
	// See if we need to su_migrate this profile
	var theid = su_read_file_global("stumbleid");
	if (theid != "" && typeof(theid) != "object")
	{
		su_migrate();
		return true;
	}

	stumbleid = su_pref_getstring_absolute("current_user");
	if (typeof(stumbleid) != "undefined" && stumbleid != "")
	{	
		stumblepass = su_pref_getstring("password");
		// Migrate stumbleurls
		var out = su_read_file_global(stumbleid + su_SLASH + "stumbleinterests");
		if (out != "")
		{
			su_migrate2();
		}

		return true;
	}

	// We have no ID yet, hit getid.php
	var res = su_get_url_server('getid.php?version=' + su_verstring, su_useragent, "");
	if (res.status == 1)
	{
		alert("StumbleUpon was unable to create an account for you.  Please try again later.");
		return false;
	}

	if (res.status != 200)
	{
		su_http_error(res.error, res.status);
		return false;
	}

	var s = res.response;

	var parsed = s.split("\n");
	// Iterate through commands
	for (var i = 0; i < parsed.length; i++)
	{
		if (parsed[i] == "")
			continue;

		// Parse command structure
		var command = parsed[i].split(" ");
		switch(command[0])
		{
			case "ERROR":
				su_handle_error(command[1]);
				stumbleid = 0;
				stumblepass = 0;
				return false;
				break;
			case "USER":
				stumbleid = command[1];
				break;
			case "PASS":
				stumblepass = command[1];
				break;
		}
	}

	if (isInt(stumbleid) && stumbleid != 0 && stumblepass != 0 && stumbleid != false && stumblepass != false && stumblepass.length>0 && stumblepass.length<=16)
	{
		su_pref_setstring_absolute("current_user", stumbleid);
		su_pref_setstring("password", stumblepass);

		// sync prefs.js in case we crash
		su_pr.save();

/*
		// create directory
		var thedir = su_prefDir + stumbleid + su_SLASH;
		var d = new su_Dir(thedir);
		d.create(0700);
*/

		get_interests();
		return true;
	}
	else
	{
		stumbleid = 0;
		stumblepass = 0;
		// spit out an error
		alert("StumbleUpon was unable to create an account for you.  Please try again later.");
		return false;
	}
}

// Handler for menuitem "Stumble On Browser Startup"
function make_homepage()
{
	var popup = su_pref_getbool("homepage");
	su_pref_setbool("homepage", !popup);
	document.getElementById("su_makehomepage").setAttribute("checked", !popup);
	
	var newhomepage = "about:blank";
	if (popup)
	{
		// we need to revert to the old homepage
		newhomepage = su_pref_getstring("old_homepage");
	}
	else
	{
		// we need to save the current homepage as old homepage
		var oldhomepage = su_pr.getChar("browser.startup.homepage", "");
		su_pref_setstring("old_homepage", oldhomepage);
	}
	su_pr.setChar("browser.startup.homepage", newhomepage);

	su_pr.save();
}

function isInt(elm) 
{
	elm = elm.toString();
	var pattern = /[^0-9]/;
	if (pattern.test(elm))
		return false;
	else
		return true;
}

function load_stumbles()
{
	stumbles = new Array();
	var stumbleseen = su_read_file_user("stumbleurls");
	if (stumbleseen != "")
	{
		var splitseen = stumbleseen.split("\n");
		
		for (var i = 0; i < splitseen.length; i++)
		{
			if (splitseen[i] == "")
				continue;
			stumbles.push(splitseen[i]);
		}
	}
}

// user_cat = incat stumble category ID
// Gets an url the users hasn't seen yet from stumbleurls
function get_unseen_url(user_cat)
{
	g_user_cat = user_cat;

	// load stumbles...
	load_stumbles();
	
	if (stumbles.length == 0)
	{
		// We need to hit the server to get urls
		recommend_callback = function(arg) {get_unseen_url_done(arg);};
		update_url_cache(user_cat, 0);
		// Did we get any urls from server?
		if (stumbles.length == 0)
			return false;
	}
	else
		get_unseen_url_done('');
	return true;
}

function get_unseen_url_done(error)
{
	if (error == "error")
	{
		unseen_callback("error");
		return false;
	}

	var user_cat = g_user_cat;

	load_stumbles();
	for (var counter = 0; counter < stumbles.length; counter++)
	{
		// Go through each seen url to see if we there's one we haven't seen already
		if (stumbles[counter] == "")
			continue;

		unseen_callback(stumbles[counter]);
		return true;
	}

	unseen_callback("");
	return true;
}

function su_prefetch()
{
//	alert("prefetching" + su_prefetch_url);
	su_cacheTimer = 0;

	var unseen = su_prefetch_url;

	// we have to set this now because the stumble will just grab from cache
	var referer = "http://www.stumbleupon.com/refer.html";

	try { prefetch_res = su_get_url_async(unseen, navigator.userAgent, referer, prefetch_done);
	} catch(e) { }
}

function prefetch_done()
{
//	alert("fetched url " + su_prefetch_url);

	//!!! don't bother continuing if we've already stumbled...

	res = prefetch_res;
	var unseen = su_prefetch_url;
	var fourofour = false;

	//!!! dunno why we have to exclude res.status = 1, something is wack with mozilla here
	if (res.status != 200 && res.status != 302 && res.status != 1)
		fourofour = true;

	// If its porn, only accept 200 (we don't like redirects from images!)
	var dontreport = false;

	if (fourofour == true)
	{
//		alert("404 : " + res.status);
		// let the server know there is a 404
		if (!dontreport)
			su_get_url_server_async('404.php?url=' + escape(unseen) + "&version=" + su_verstring + "&status=" + res.status, su_useragent, "", null_function);

		// nuke it from our queue
		load_stumbles();

		while (typeof(stumbles[0]) != "undefined" && stumbles[0].split(" ")[0] != unseen)
			stumbles.shift();
		if (stumbles[0].split(" ")[0] == unseen)
			stumbles.shift();

		save_stumbles();

		//!!! we could loop this if we want to exhaustively search the queue for non-404 urls
	}	
	else
	{
//		alert("no 404..");
		// prefetch images from current doc

		var _regExp=/<img [^\s]*[\s]?src=[^>]*>/gi;
		var matches = res.responseText.match(_regExp);
		var ims = '';
		var imgs = new Array();
		if (matches != null)
		{
			for (var i = 0; i < matches.length; i++)
			{
				//!!! don't get repeats!
				var m = matches[i];
				
				start = 0;
				cut_start = 0;
				cut_end = m.length;
				for (var j = 0; j < m.length; j++)
				{
					if (start == 0)	
					{
						if (m.substr(j, 3).toLowerCase() == "src")
						{
							if (m[j+4] == "\"" || m[j+4] == "'")
								cut_start = j+5;
							else
								cut_start = j+4;
							start = 1;
							j+=5;
						}
					}
					else
					{
						if (m[j] == "'" || m[j] == " " || m[j] == ">" || m[j] == '"')
						{
							cut_end = j;
							break;
						}
					}
				}
				m = m.substr(cut_start, cut_end - cut_start);

				// don't grab offsite urls as they are probably ads (and may be blocked by an ad filter)
				//!!! okay, don't do it for now
				//!!! if (m.toLowerCase().indexOf("http://")==-1)
				imgs[m] = 1;			
			}
	
			// trim url
			var relative_url = "";
			var absolute_url = "";
	
			var slashes = 0;
			for (i = 0; i < unseen.length; i++)
			{
				if (unseen[i] == '/')
				{
					slashes++;
				}
				if (slashes == 3)
				{
					absolute_url = unseen.substr(0, i);
					break;
				}
			}
			if (absolute_url == '')
				absolute_url = unseen;
	
			for (i = unseen.length - 1; i >=0; i--)
			{
				if (i == absolute_url.length - 1)
				{
					relative_url = absolute_url + "/";
					break;
				}
	
				if (unseen[i] == '/')
				{
					relative_url = unseen.substr(0, i+1);
					break;
				}
			}
//			alert(relative_url);
//			alert(absolute_url);
	
			var imgurl = '';
			for (var d in imgs)
			{
				var PersistAPI = Components.Constructor('@mozilla.org/prefetch-service;1', 'nsIPrefetchService');
				var persistAPI = new PersistAPI;
				var DocURI = Components.Constructor('@mozilla.org/network/standard-url;1', 'nsIURI');
				var docURI = new DocURI;
				var refererURI = new DocURI;
				refererURI.spec = unseen;
				if (d.toLowerCase().indexOf("http://")!=-1)
				{
					imgurl = d;	
				}
				else
				{
					if (d[0] == '/')
						imgurl = absolute_url + d;
					else
						imgurl = relative_url + d;		
				}
				ims += " " + imgurl + " : ";

				// prefetch img url...
				try { docURI.spec = imgurl; persistAPI.prefetchURI(docURI, refererURI, false);
				} catch (e) { }
				// alert("prefetch " + docURI.spec + " " + refererURI.spec);
			}
//			alert("IMAGES : " + matches.length + " : " + ims);
		}
	}
}

function enable_stumble_button()
{
	document.getElementById("stumble").disabled=false;
}

// Handler for button "Stumble"
function stumble(middle_click) 
{
	// See if they are not logged in
	var getit = su_pref_getstring_absolute("current_user");
	if (getit == false)
	{
		// okay, they are not logged in		

		// see if they've already created/used an account with this toolbar
		var id_list = su_pref_getstring_absolute("ids");
		
		var splitids = id_list.split(":");
		var oldid = 0;
		for (var i = 0; i < splitids.length; i++)
		{
			if (splitids[i] == "")
				continue;
			
			oldid = splitids[i];
			break;
		}
		if (oldid)
		{
			// they already have an account
			var signinWindow = "chrome://stumbleupon/content/signinDialog.xul";
			window.openDialog(signinWindow, "Sign-In", "chrome,modal,dialog,centerscreen,dependent");
			return;
		}
		else
		{		
			// they've never created an account before, so create a new one
			var newuserWindow = "chrome://stumbleupon/content/newuserWindow.xul";
			window.open(newuserWindow, "Welcome to StumbleUpon", "chrome,modal,dialog,centerscreen,dependent");
			return;
		}
	}

	// redo su_changeInterval
	clearInterval(su_changeInterval);
	su_changeInterval = setInterval("su_oneMinute()", 300000);

	// disable stumble button for a few seconds to prevent people hammering 
	document.getElementById("stumble").disabled=true;
	setTimeout("enable_stumble_button()", 2000);

	// people can't report a stumble as 404/spam until they actually stumble
	document.getElementById("su_report-menu").setAttribute("disabled", "false");

	if (su_cacheTimer != 0)
	{
		clearTimeout(su_cacheTimer);
		su_cacheTimer = 0;
	}

	if (stumbleid == 0)
		return;

	first_stumble_day = 0;
	// See if this is the first stumble of the day
	var oldTime = su_pref_getstring("last_stumble");
	if (typeof(oldTime) == "undefined" || oldTime == "")
		oldTime = 0;

	var oldDate = new Date();
	oldDate.setTime(oldTime);

	var newDate = new Date();

	// see if new day is the same as today
	var newDay = newDate.getDate();
	var oldDay = oldDate.getDate();
	var newMonth = newDate.getMonth();
	var oldMonth = oldDate.getMonth();
	var newYear = newDate.getYear();
	var oldYear = oldDate.getYear();

	if (oldTime != 0)
	{
		if (oldDay != newDay || oldMonth != newMonth || oldYear != newYear)
		{
			first_stumble_day = 1;
			// clear stumbles
			clear_stumbles();
		}
	}

	// now set last_stumble
	su_pref_setstring("last_stumble", newDate.getTime());
	su_pr.save();

	// See if this is an incat thingy
	var user_cat = document.getElementById("su_category").selectedIndex;
	g_user_cat = user_cat;

//	alert("USER CAT " + user_cat + " NEW CAT " + parseInt(su_pref_getstring("last_incat")));

	// If user_cat != 0, then we are doing an incat stumble
	if (user_cat != parseInt(su_pref_getstring("last_incat")))
	{
//		alert("NEW CAT!");
		// We have a new incat stumble and old cat was not "All" (and therefore we should clear the queue)
		clear_stumbles();
	}

	su_pref_setstring("last_incat", user_cat);

	var unseen = "";
	// We attempt to find an unseen url from recommend.php twice before giving up
	// changed to once now that we have seenurl removal on server

	unseen_callback = function(arg) {stumble_done(arg);};	
	g_middle_click = middle_click;
	get_unseen_url(user_cat);
}

function unseen_prefetch_done(unseen_raw)
{
	//!!! Don't prefetch/404 check against stumbleupon
	if (unseen_raw.indexOf(su_base_url)==-1)
	{
		// Now look for another unseen url (so we can do a 404 check on it)
		// we do next stumble prefetching at the same time as 404 checking..
		var unseen = unseen_raw.split(" ")[0];
		var actual_url = "";
 		if (typeof(unseen_raw.split(" ")[3]) != "undefined" && unseen_raw.split(" ")[3] != "")
		{
			// if we have an actual_url (redirect) then prefetch that url instead of the main url
			actual_url = unseen_raw.split(" ")[3];
			unseen = actual_url;
		}
		if (unseen == "error")
			return;
		if (unseen == "")
			return;

 		if (typeof(unseen_raw.split(" ")[7]) != "undefined" && unseen_raw.split(" ")[7] == 3)
		{
			// sponsored, don't prefetch
			return;
		}

		if (su_pref_getbool("prefetch"))
		{
			// Set up a timer, we want to wait until the current 
			// stumble is done before we start precaching and 404 checking the next one
			su_prefetch_url = unseen;
			su_cacheTimer = setTimeout("su_prefetch()", 2000);
		}
	}

	// We're done, success
	return;
}

// nick = firstrater nickname, status=sponsored/referral/firstrater, last_stumbled = timestamp of stumble
// this object is used in the global array "firstraters"
function FirstraterObj (nick, status, comment_level, last_stumbled, url) {this.nick = nick;  this.status = status; this.comment_level = comment_level; this.last_stumbled = last_stumbled; this.url=url }

function clear_first_rater()
{
	document.getElementById("firstrater").hidden = true;
	document.getElementById("su_sponsor").hidden = true;
	document.getElementById("su_website-info").image="chrome://stumbleupon/content/skin/bubble.png";

}

function clear_stumble_topic()
{
	document.getElementById("su_stumble_topic").hidden = true;
}

function set_first_rater(fraterObj)
{
//	alert("set first rater");
	if (fraterObj.status == "sponsored")
	{
//		alert("sponsor");
		// sponsor
	
		// Hide firstrater button
		document.getElementById("firstrater").hidden = true;
	
		// Set and show sponsor button
		frater = document.getElementById("su_sponsor");
		frater.hidden=false;
		frater.setAttribute("tooltiptext","The site " + fraterObj.url + " is sponsored");
	}
	else
	{
		// nonsponsor
	
		// Hide sponsor button
		frater = document.getElementById("su_sponsor");
		frater.hidden=true;

		// Set and show firstrater button
		frater = document.getElementById("firstrater");
		frater.hidden=false;
		var tooltip;
		tooltip = "View ";
		frater.label=fraterObj.nick;
		tooltip += fraterObj.nick;
		if (fraterObj.status == "referral")
		{
			frater.image = "chrome://stumbleupon/content/skin/friend.png";
			tooltip += " who sent you: ";
		}
		else
		{
			frater.image = "chrome://stumbleupon/content/skin/firstrater.png";
			tooltip += " who suggested: ";
		}

		tooltip += fraterObj.url;
		frater.firstrater=fraterObj.nick;
		frater.setAttribute("tooltiptext", tooltip);

		var comment_level = fraterObj.comment_level;
		var winfo = document.getElementById("su_website-info");
		if (comment_level == 0)
			winfo.image="chrome://stumbleupon/content/skin/bubble.png";
		else
			winfo.image="chrome://stumbleupon/content/skin/bubble" + comment_level + ".png";
	}
}

function set_stumble_topic(topic)
{
	if (!su_pref_getbool("stumble_topics"))
		return;
		
	document.getElementById("su_stumble_topic").hidden=false;
	// miscat page...

	var command = "auth_server_url(\"misclassified.php?url=" + escape(stumbled_url) + "\", 1)";
	document.getElementById("su_stumble_topic").setAttribute("oncommand", command);

	if (typeof(su_catnames[topic]) != "undefined")
		document.getElementById("su_stumble_topic").label=su_catnames[topic];
	else
		document.getElementById("su_stumble_topic").label='Unknown Topic';
}

function su_tld(url)
{
//	alert('TLD ' + url);
	var spliturl = url.split("/");
	var newtld = '';
	for (var i = 0; i < spliturl.length && i < 3 ; i++)
	{
		newtld += spliturl[i];
		if (i != 2)
			newtld += "/";
	}
	return newtld;
}

function stumble_done(unseen)
{
	var user_cat = g_user_cat;
	if (unseen == "error")
		return;

	if (unseen != "")
	{
		// We found an unseen url in the cache, go to it
		stumbled_url = unseen.split(" ")[0];
		if (unseen.split(" ").length > 8)
			stumbled_urlid = unseen.split(" ")[8];
		else
			stumbled_urlid = 0;

		if (unseen.split(" ").length > 2 && unseen.split(" ")[2] != '')
			referer = unseen.split(" ")[2];
		else
			referer = "http://www.stumbleupon.com/refer.html";

		if (unseen.split(" ").length > 11)
			stumbled_type = unseen.split(" ")[11];
		else
			stumbled_type = 0;

		var da = new Date();

		// Prefetch the affiliate link for this url if there is one
		var preurl = "";
		if (unseen.split(" ").length > 9)
			preurl = unseen.split(" ")[9];
	
		//!!! send custom referer!!!
		try { su_get_url_async(preurl, navigator.userAgent, referer, null_function);
		} catch(e) { }

		just_stumbled = true;
	
		var browser = getBrowser();
		var DocURI = Components.Constructor('@mozilla.org/network/standard-url;1', 'nsIURI');
		var referrerURI = new DocURI;
		referrerURI.spec = referer;
		var characterSet = browser.contentDocument.characterSet;

		var middle_click = g_middle_click;
		if (middle_click == 1)
		{
			var tab = browser.addTab(stumbled_url, referrerURI, characterSet);
			browser.selectedTab = tab;
		}
		else
		{
			su_dd("------ loadURI", stumbled_url, referrerURI.spec, referrerURI);
			
			browser.webNavigation.loadURI(stumbled_url, 0, referrerURI, null, null)
			// loadURI ( PRUnichar* uri , PRUint32 loadFlags , nsIURI referrer , nsIInputStream postData , nsIInputStream headers )
		}


		// add to stumblestats to be uploaded later
		if (stumbled_urlid != 0 && stumbled_urlid != "")
		{
			var stumblestats = su_pref_getstring("stumblestats");
			if (stumblestats != "")
				stumblestats += ".";
			stumblestats += stumbled_urlid;
			su_pref_setstring("stumblestats", stumblestats);

			var stumbletimes = su_pref_getstring("stumbletimes");
			if (stumbletimes != "")
				stumbletimes += ".";
			stumbletimes +=  parseInt(da.getTime() / 1000);
			su_pref_setstring("stumbletimes", stumbletimes);

			var stumbletypes = su_pref_getstring("stumbletypes");
			if (stumbletypes != "")
				stumbletypes += ".";
			stumbletypes += stumbled_type;
			su_pref_setstring("stumbletypes", stumbletypes);

			su_pr.save();
		}

		// Remove the url we just stumbled upon from our local stumble queue
		load_stumbles();
		// go through the array, taking off the first url of the array until we find the one we just 
		// stumbled upon
		while (typeof(stumbles[0]) != "undefined" && stumbles[0].split(" ")[0] != stumbled_url)
			stumbles.shift();

		// remove the url we just stumbled upon
		if (stumbles[0].split(" ")[0] == stumbled_url)
			stumbles.shift();

		save_stumbles();

		// check to see if this is a referral
		if (typeof(unseen.split(" ")[7]) != "undefined" && unseen.split(" ")[7] == 4)
		{
			// This is a referral
			// 1. popup of the note if there is one
			if (typeof(unseen.split(" ")[12]) != "undefined" && unseen.split(" ")[12] != '')
			{
				var note = unseen.split(" ")[12];
				// change pipe to space
				note = note.replace(/\|/g, ' ');
				var firstrater = unseen.split(" ")[5];
				var firstnick = unseen.split(" ")[6];
				var person = firstrater;
				if (firstnick != '')
					person = firstnick;
				if (note != '')
					alert("Message from " + person + ":\n\n" + note);
			}	
			// 2. decrement referral count
			var referral_count = parseInt(su_pref_getstring("referral_count"));
			referral_count--;
			su_pref_setstring("referral_count", referral_count);
			if (referral_count <= 0)
				document.getElementById("su_inbox-count").hidden=true;
			else
 				document.getElementById("su_inbox-count").hidden=false;

			document.getElementById("su_inbox-count").value=referral_count;
		}

		var topic = null;

		// show topic
		// We'll store the topic after we do the firstrater thing.
		// !!!  We can combine the firstraters array and the su_topics array to make a
		// stumble metadata map after we handle redirects better.
		if (typeof(unseen.split(" ")[1]) != "undefined")
		{
			topic = unseen.split(" ")[1];

			set_stumble_topic(topic);
		}
		
		// do first rater thing
		// first see if this is sponsored
		var frater;

		da = new Date();
		var timenow = da.getTime() / 1000;
		var fraterObj = null;

		// Clear old sponsor or firstrater buttons
		document.getElementById("su_sponsor").hidden=true;
		document.getElementById("firstrater").hidden=true;

//!!! actual url!!!
		var actual_url = "";
 		if (typeof(unseen.split(" ")[3]) != "undefined" && unseen.split(" ")[3] != "")
		{
			actual_url = unseen.split(" ")[3];
//			alert("URL " + stumbled_url + " ACTUAL URL " + actual_url);	
		}

		if (typeof(unseen.split(" ")[7]) != "undefined" && unseen.split(" ")[7] == 3)
		{
//			alert("sponsored");
			// URL is sponsored
			if (actual_url != "")
				fraterObj = new FirstraterObj("", "sponsored", 0, timenow, actual_url);
			else
				fraterObj = new FirstraterObj("", "sponsored", 0, timenow, stumbled_url);
		}
		else
		{
			// URL is not sponsored
			if (typeof(unseen.split(" ")[5]) != "undefined")
				firstnick = unseen.split(" ")[5];
			else
				firstnick = "";
			if (typeof(firstnick) != "undefined" && firstnick != "")
			{
				var comment_level = 0;
				if (typeof(unseen.split(" ")[10]) != "undefined" && unseen.split(" ")[10] != "")
					comment_level = unseen.split(" ")[10];

				var status = "firstrater";
				if (typeof(unseen.split(" ")[7]) != "undefined" && unseen.split(" ")[7] == 4)
					status = "referral";
				if (actual_url != "")
					fraterObj = new FirstraterObj(firstnick, status, comment_level, timenow, actual_url);
				else
					fraterObj = new FirstraterObj(firstnick, status, comment_level, timenow, stumbled_url);
			}
		}
		if (fraterObj != null)
		{
			var newtld = '';
			if (actual_url != "")
				newtld = su_tld(actual_url);
			else
				newtld = su_tld(stumbled_url);
			firstraters[newtld] = fraterObj;
			// set_first_rater(fraterObj);
		}

		// store the topic
		
		if (topic != null)
		{
			var newtld = '';
			if (actual_url != "")
				newtld = su_tld(actual_url);
			else
				newtld = su_tld(stumbled_url);
			su_topics[newtld] = topic;
		}


		// alert(stumbled_url);
		if (stumbled_url.indexOf('first_stumble.php')==-1)
		{
			unseen_callback = function(arg) {unseen_prefetch_done(arg);};
			get_unseen_url(user_cat);
		}
	}
	else
	{
		// We couldn't find an unseen url...
		// Check to make sure this isn't an incat stumble
		if (user_cat != 0)
		{
			// User is doing an incat stumble
			// Set user_cat to 0
			document.getElementById("su_category").selectedIndex = 0;
			document.getElementById("su_category").label = "All";
			// Give them a message explaining they have run out in their particular cat.
			var page = "<html><head><title>Out of Sites</title>\r\n\ \
<style type=\"text/css\">\r\n\ \
table.thickborder {border-style: solid; border-color: #888888; border-width: 2}\r\n\ \
td.rightborder {border-right-style: solid; border-right-color: #888888; border-right-width: 2}\r\n\ \
* {font-family: verdana,arial,helvetica,sans-serif; font-size: 12pt}\r\n\ \
</style></head><body bgcolor=#ffffff text=#000000 link=#0000ff marginheight=0 topmargin=0 border=0>\r\n\ \
<center><br><br><br><br>\r\n\ \
<table cellspacing=0 cellpadding=25 class=thickborder width=\"670\" summary=\"stumbleupon.com\"><tr>\r\n\ \
<td bgcolor=\"#f0f3f5\" height=250 valign=center width=50%><font color=\"#000000\" face=\"arial,helvetica\" size=\"2\">\r\n\ \
  <b>StumbleUpon cannot find any more high-quality sites within this topic or friend. \
Please choose a different friend or topic, or try back in a few days. \
</td></tr></table></center></body></html>";
			var doc = getBrowser().contentDocument;
			doc.writeln(page);
			doc.close();
			return;
		}
		else
		{
			// If we got here, we're out of urls, and we're in "Any Topic"
			//!!! first make sure we are not already here....
			getBrowser().contentDocument.location = su_serverhttp + "interests.php?username=" + stumbleid + "&password=" + escape(stumblepass) + "&out=1";

			return;
			//!!! eventually we should cycle through "great history" here
		}
	}
}

// Handler for menitem "Suggest New Interests"
function su_suggest()
{
	getBrowser().contentDocument.location = su_serverhttp + "suggest_interests.php?username=" + stumbleid + "&password=" + escape(stumblepass);
}

// Handler for menuitem "Update Interests"
function su_interests()
{
	if (stumbleid == 0)
		return;

	// Redirect to interests page
	var loc = su_serverhttp + "interests.php?username=" + stumbleid + "&password=" + escape(stumblepass);

	//!!! disabled because it screws up history
	// if (getBrowser().contentDocument.location.toString() != loc)

	getBrowser().contentDocument.location = loc;
}

// Handler for button "Toolbar Preferences"
function su_preferences()
{
	if (stumbleid == 0)
		return;

	var prefWindow = "chrome://stumbleupon/content/preferenceDialog.xul";
	window.openDialog(prefWindow, "Preferences", "chrome,modal,dialog,centerscreen,dependent", this, stumbleid);
}

function su_show_icons(icons_only)
{
	if (icons_only == "icons-only")
	{
		// nuke all button captions...
		document.getElementById("stumble").label='';
		document.getElementById("su_thumbup").label='';
		document.getElementById("su_thumbdown").label='';
		document.getElementById("stumble-menu").label='';
		document.getElementById("su_forum").label='';
		document.getElementById("su_home").label='';
		document.getElementById("su_profile").label='';
		document.getElementById("su_friends").label='';
		document.getElementById("su_matches").label='';
		document.getElementById("su_aboutme").label='';
		document.getElementById("su_groups").label='';
		document.getElementById("su_messages").label='';
		document.getElementById("su_editinfo").label='';
		document.getElementById("su_website-info").label='...';	
		document.getElementById("su_referral-menu").label='';
	}
	else
	{
		document.getElementById("stumble").label=document.getElementById("stumble").getAttribute('showlabel');
		document.getElementById("su_thumbup").label=document.getElementById("su_thumbup").getAttribute('showlabel');
		document.getElementById("su_thumbdown").label=document.getElementById("su_thumbdown").getAttribute('showlabel');
		document.getElementById("stumble-menu").label=document.getElementById("stumble-menu").getAttribute('showlabel');

		if (icons_only == "text-icons")
		{
			document.getElementById("su_forum").label='';
			document.getElementById("su_home").label='';
			document.getElementById("su_profile").label='';
			document.getElementById("su_messages").label='';
			document.getElementById("su_groups").label='';
			document.getElementById("su_friends").label='';
			document.getElementById("su_matches").label='';
			document.getElementById("su_aboutme").label='';
			document.getElementById("su_editinfo").label='';
			document.getElementById("su_referral-menu").label='';
			document.getElementById("su_website-info").label='...';
		}
		else if (icons_only == "extra-text")
		{
			document.getElementById("su_forum").label=document.getElementById("su_forum").getAttribute('showlabel');
			document.getElementById("su_home").label=document.getElementById("su_home").getAttribute('showlabel');
			document.getElementById("su_profile").label=document.getElementById("su_profile").getAttribute('showlabel');
			document.getElementById("su_groups").label=document.getElementById("su_groups").getAttribute('showlabel');
			document.getElementById("su_messages").label=document.getElementById("su_messages").getAttribute('showlabel');
			document.getElementById("su_friends").label=document.getElementById("su_friends").getAttribute('showlabel');
			document.getElementById("su_matches").label=document.getElementById("su_matches").getAttribute('showlabel');
			document.getElementById("su_aboutme").label=document.getElementById("su_aboutme").getAttribute('showlabel');
			document.getElementById("su_editinfo").label=document.getElementById("su_editinfo").getAttribute('showlabel');
			document.getElementById("su_website-info").label=document.getElementById("su_website-info").getAttribute('showlabel');
			document.getElementById("su_referral-menu").label=document.getElementById("su_referral-menu").getAttribute('showlabel');
		}
	}
}

// Handler for button "Invite Friends"
function su_invite(favorites_of)
{
	if (stumbleid == 0)
		return;

	// Redirect to home
	var location_url = su_serverhttp + "invite_friends.php?username=" + stumbleid + "&password=" + escape(stumblepass);
	if (favorites_of)
		location_url += "&favorites_of=1";
	getBrowser().contentDocument.location = location_url;
}

// Handler for button "Upgrade Now"
function su_sponsor(extra)
{
	if (stumbleid == 0)
		return;

	// Redirect to sponsor page
	getBrowser().contentDocument.location = su_serverhttp + "sponsors.php?username=" + stumbleid + "&password=" + escape(stumblepass) + extra;
}

function stumblers_func(event)
{
	if (stumbleid == 0)
		return false;
	if (event.button == 0)
		stumblers(0);
	if (event.button == 2 || event.button == 1)
		stumblers(1);
	return true;
}

// Handler for button "My Stumblers"
function stumblers(middleclick)
{
	if (stumbleid == 0)
		return;
	
	//!!! we need nickname?
	if (middleclick)
		session_redir_absolute("home", "stumblers", 1);
	else
		session_redir_absolute("home", "stumblers", 0);
}

// handler for tab buttons
function redir_tab(event, tab)
{
	if (stumbleid == 0)
		return false;
	if (event.button == 0)
		session_redir_absolute("home", tab, 0);
	if (event.button == 2 || event.button == 1)
		session_redir_absolute("home", tab, 1);
	return true;
}

// Handler for menuitem "My Great Sites"
function great_history()
{
	if (stumbleid == 0)
		return;

	// Redirect to home
	var loc = su_serverhttp + "history.php?rating=1&username=" + stumbleid + "&password=" + escape(stumblepass);

	//!!! disabled because it screws up history
	// if (getBrowser().contentDocument.location.toString() != loc)


	getBrowser().contentDocument.location = loc;
}

// Handler for menuitem "Stumble History"
function stumble_history()
{
	if (stumbleid == 0)
		return;

	var loc = '';

	// make sure we don't need to upload some stumbles
	if (su_pref_getstring("stumblestats") != "")
	{
		loc = su_serverhttp + 'history.php?username=' + stumbleid + '&password=' + escape(stumblepass) + "&urlids=" + escape(su_pref_getstring("stumblestats")) + "&timestamps=" + escape(su_pref_getstring("stumbletimes")) + "&types=" + escape(su_pref_getstring("stumbletypes"));
	
		//!!! ignore errors

		// Now nuke all the variables and write them to disk
		su_pref_setstring("stumblestats", "");
		su_pref_setstring("stumbletimes", "");
		su_pref_setstring("stumbletypes", "");
		var da = new Date();
		su_pref_setstring("last_uploaded", da.getTime());
		su_pr.save();
	}
	else
	{
		// Redirect to home
		loc = su_serverhttp + "history.php?username=" + stumbleid + "&password=" + escape(stumblepass);
	}

	getBrowser().contentDocument.location = loc;
}

function null_function()
{
	// do nothing, callback for async
}

// Sends stumble stats to server (urls and dates you've stumbled upon)
function upload_stumbles()
{
	su_get_url_server_async('stumbles.php?username=' + stumbleid + '&password=' + escape(stumblepass) + "&urlids=" + escape(su_pref_getstring("stumblestats")) + "&timestamps=" + escape(su_pref_getstring("stumbletimes")) + "&types=" + escape(su_pref_getstring("stumbletypes")) + "&version=" + su_verstring, su_useragent, "", null_function);
	//!!! ignore errors
	//!!! we should not clear_upload_stumbles if this fails...
	clear_upload_stumbles();
}

function clear_upload_stumbles()
{
	// Now nuke all the variables and write them to disk
	su_pref_setstring("stumblestats", "");
	su_pref_setstring("stumbletimes", "");
	su_pref_setstring("stumbletypes", "");
	var da = new Date();
	su_pref_setstring("last_uploaded", da.getTime());
	su_pr.save();
}

// Get rid of the stumble queue
function clear_stumbles()
{
	stumbles = new Array();
//	su_fu.remove(su_prefDir + "stumbleurls");
	su_write_file_user("stumbleurls", "");
}

function su_compareNumbers(a, b) { return b.value - a.value; }

function KeyValueObj (key, value) { this.key = key; this.value = value; }

function update_message_status(icon)
{
	var message_element = document.getElementById("su_messages");
	var newimage = "chrome://stumbleupon/content/skin/mail" + icon + ".png";
	if (message_element.image != newimage)
	{
		message_element.image = newimage;

		// right now we don't save between sessions
		if (icon == 2)
		{
			su_pref_setbool("newmessage", true);
			if (!su_pref_getbool("show_messages"))
				document.getElementById("su_messages").hidden=false;
		}
		else
		{
			if (!su_pref_getbool("show_messages"))
 				document.getElementById("su_messages").hidden=true;
			su_pref_setbool("newmessage", false);
		}
	}
	su_pr.save();
}

function su_sendto(friend)
{
	if (stumbleid == 0)
		return;

	var current_page = getBrowser().contentDocument.location.href.toString();
	var note = getBrowser().contentWindow.prompt("Note to " + friend + " about:\n\n" + current_page,"");
	if (typeof(note) == "undefined" || note == null)
		return;

	su_get_url_server_async('referral.php?url=' + escape(current_page) +  "&username=" + escape(stumbleid) + "&password=" + escape(stumblepass) + "&friend=" + friend + "&note=" + escape(note) + "&version=" + su_verstring, su_useragent, "", null_function);
	// ignore error
}

function update_referral_menu()
{
	var friends = su_pref_getstring("friends");
	var parsed_friends = friends.split(' ');
	var referral_menu = document.getElementById("su_referral-menu");

	// Nuke all the children and then add them from user_interests
	var children = referral_menu.childNodes[0].childNodes;
	for (var i = 0; i < children.length; i++)
	{
		if (children[i].id != "su_mail-menu")
			referral_menu.childNodes[0].removeChild(children[i]);
	}

	var has_friends = 0;
	for (i = 1; i < parsed_friends.length; i++)
	{
		has_friends = 1;
		var ja = document.createElement("menuitem");
		ja.setAttribute("label", parsed_friends[i]);

		ja.setAttribute("oncommand", "su_sendto(\"" + parsed_friends[i] + "\");");
		referral_menu.childNodes[0].appendChild(ja);
	}

	if (!su_pref_getorsetbool("show_referral", true))
		referral_menu.hidden = true;
	else
		referral_menu.hidden = false;
}

// This function grabs urls from recommend.php and stores them in stumbleurls (user_cat is either category id of incat stumble or 0)
function update_url_cache(user_cat, check_referral)
{
	var res;
	var getline = 'recommend.php?';
	if (first_stumble_day == 1)
		getline += 'first_of_day=1&';
	getline += 'username=' + stumbleid + '&password=' + escape(stumblepass)  + "&salt=" + Math.random() + "&version=" + su_verstring;

	if (isInt(user_cat) || user_cat == "news")
		getline += "&category=" + user_cat;
	else
		getline += "&showfriend=" + user_cat;

	if (check_referral)
	{
		su_check_referral = 1;
		getline += "&check_referral=1";
	}
	else
	{
		su_check_referral = 0;
	}
	
	// if we need to upload_stumbles, do it
	if (su_pref_getstring("stumblestats") != "")
	{
		getline += "&urlids=" + escape(su_pref_getstring("stumblestats")) + "&timestamps=" + escape(su_pref_getstring("stumbletimes")) + "&types=" + escape(su_pref_getstring("stumbletypes"));
		//!!! ignore errors
		//!!! we should not clear_upload_stumbles if this fails...
		clear_upload_stumbles();
	}
	
	var referer = "http://www.stumbleupon.com/refer.html";
	recommend_res = su_get_url_server_async(getline, su_useragent, referer, update_url_cache_done);
}

function update_url_cache_done()
{
	var res = recommend_res;

	if (res.status == 1)
	{
		recommend_callback("error");
		return;
	}

	if (res.status != 200)
	{
		alert("The stumbleupon.com server is currently down.\nPlease try again, and if you are still having difficulties,\ngo to http://www.stumbleupon.com/feedback.php to report the problem\nError : " + res.error + "\nStatus : " + res.status);
		recommend_callback("error");
		return;
	}
	var s = res.responseText;

	su_dd("------ COMMANDS", s);

	// Parse response text
	var parsed = s.split("\n");

	var referral_count = 0;

	var pre_stumbles = new Array(); // temporary variable for storing stumbles if we are checking referrals

	// Iterate through commands
	for (var i = 0; i < parsed.length; i++)
	{
		if (parsed[i] == "")
			continue;

		// Parse command structure
		var command = parsed[i].split(" ");
		switch(command[0])
		{
			case "URL":
				pre_stumbles.push(parsed[i].substr(4));
				// Check to see if we have a referral
				if (typeof(command[8]) != "undefined" && command[8] == 4)
					referral_count++;
				break;
			case "MESSAGE": update_message_status('2'); break;
			case "FRIEND": 
				su_pref_setstring("friends", parsed[i]);
				update_referral_menu(); 
				update_favorites_of();
				break;
			case "NICK": 
				su_pref_setstring("nick", command[1]);
				break;
			case "FIRSTFRIEND": 
				su_pref_setstring("firstfriends", parsed[i]);
				update_favorites_of();
				break;
			case "SPONSOR": su_pref_setbool("sponsor", true); break;
			case "NOSPONSOR": su_pref_setbool("sponsor", false); break;
			case "ERROR":
				// silently fail if we are just checking referral in the background
				if (su_check_referral)
					break;

				if (command[1] == "NO_INTERESTS")
				{
					// Redirect to interests page
					var loc = su_serverhttp + "interests.php?username=" + stumbleid + "&password=" + escape(stumblepass) + "&version=" + su_verstring;
					//!!! disabled because it screws up history
					// if (getBrowser().contentDocument.location.toString() != loc)

					getBrowser().contentDocument.location = loc;

					recommend_callback("error");
					return;
				}
				if (command[1] == "NO_SITES")
				{
					// do nothing
				}
				else
				{
					su_handle_error(command[1]);
					recommend_callback("error");
					return;
				}
				break;
		}
	}

	// save referral count
	su_pref_setstring("referral_count", referral_count);

	// might as well clear old stumbles, they are old
	// and there really should only be 1 of them anyway
	if (!(su_check_referral && referral_count == 0))
		clear_stumbles();

	// if referral count > 0, show the su_inbox-count and set it
	if (referral_count > 0)
	{
		// show red number of urls waiting	
		document.getElementById("su_inbox-count").value=referral_count;
		document.getElementById("su_inbox-count").hidden=false;
	}
	else
	{
		document.getElementById("su_inbox-count").hidden=true;
	}
	
	// populate the stumbles array
	load_stumbles();

	// dump the new stumbles onto the end of stumbles
	for (i = 0; i < pre_stumbles.length; i++)
		stumbles.push(pre_stumbles[i]);

	// Now dump the new stumble queue to disk
	save_stumbles();

	recommend_callback("");
}

function save_stumbles()
{
	var towrite = "";
	for (var ii = 0; ii < stumbles.length; ii++)
		towrite += stumbles[ii] + "\n";
	su_write_file_user("stumbleurls", towrite);
}

// Saves a rating to the rating history (so we can grey out rating buttons later)
function su_store_rating(u, c)
{
	// Load rating history (in case the user has rated something in another window)
	stumblecat = su_read_file_user("stumblerating");
	splitcat = stumblecat.split("\n");
	for (i = 0; i < splitcat.length; i++)
	{
		if (splitcat[i] == "")
			continue;
		split2 = splitcat[i].split(" ");
		su_ratings[split2[0]] = split2[1];
	}

	// Add the new rating
	su_ratings[u] = c;

	// Now dump it to disk
	var towrite = "";
	for (var ii in su_ratings)
		towrite += ii + " " + su_ratings[ii] + "\n";
	su_write_file_user("stumblerating", towrite); 
}

function su_delete_rating(u)
{
	// Load rating history (in case the user has rated something in another window)
	stumblecat = su_read_file_user("stumblerating");
	splitcat = stumblecat.split("\n");
	su_ratings = new Array();
	for (i = 0; i < splitcat.length; i++)
	{
		if (splitcat[i] == "")
			continue;
		split2 = splitcat[i].split(" ");
		if (split2[0] != u)
			su_ratings[split2[0]] = split2[1];
	}

	// Now dump it to disk
	var towrite = "";
	for (var ii in su_ratings)
		towrite += ii + " " + su_ratings[ii] + "\n";
	su_write_file_user("stumblerating", towrite); 
}

// Get an url from the stumbleupon server
function su_get_url_server(geturl, uagent, referer)
{
	return su_get_url(su_serverhttp + geturl, uagent, referer);
}

// This function trys to get an url 3 times (since there is something screwy with xmlhttprequest)
function su_get_url(geturl, uagent, referer)
{
	var ret2 = new Object();
	var x;
	var status;
	var retries = 3;
	for (var i = 1; i <= retries; i++)
	{
		x = new XMLHttpRequest();
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
		x.open("GET", geturl, false);
		if (uagent != "")
			x.setRequestHeader("User-Agent" , uagent);
		if (referer != "")
			x.setRequestHeader("Referer", referer);
		try
		{ 
			x.send(null); 
			status = x.status;
			break;
		}
		catch (e)
		{
			if (i == retries) 
			{
				// Failed on 3nd try, bail out
				ret2.error = e;
				ret2.response = "";
				ret2.status = 1;
				return ret2;
			}
		}
	}
	ret2.error = "";
	ret2.response = x.responseText;
	if (typeof(ret2.response) == "undefined")
		ret2.response = "";
	ret2.status = x.status;
	var mime = '';
	try { mime = x.getResponseHeader("Content-Type"); }
	catch (e) { mime = ''; }
	if (mime != null && typeof(mime) != "undefined" && mime != '')
	{
		var mimes = mime.split(";");
		ret2.mimetype	= mimes[0];
	}
	else
		ret2.mimetype = '';
	return ret2;
}

// Get an url from the stumbleupon server
function su_get_url_server_async(geturl, uagent, referer, callback)
{
	return su_get_url_async(su_serverhttp + geturl, uagent, referer, callback);
}

// This function trys to get an url asynchronously
function su_get_url_async(geturl, uagent, referer, callback)
{
	var x = new XMLHttpRequest();
	x.onload=callback;
	netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	x.open("GET", geturl, true);
	if (uagent != "")
		x.setRequestHeader("User-Agent" , uagent);
	if (referer != "")
		x.setRequestHeader("Referer", referer);
	x.send(null); 
	return x;
}

function click_su_website_info(event)
{
	if (event.button == 0)
		su_website_info(0);
	if (event.button == 2 || event.button == 1)
		su_website_info(1);
}

function clickstumble(event)
{
	// if button is disabled, bail out
	if (document.getElementById("stumble").disabled == true)
		return;

	if (event.button == 0)
		stumble(0);
	if (event.button == 2 || event.button == 1)
		stumble(1);
}

// Handler for photoblog
function blogImage(rating)
{
	// first do rating...
	su_rate(rating, 0, 1);	

	// now wait a couple seconds, then do su_website_info
	photoblogimage = document.popupNode;
	setTimeout("su_website_info(0)", 2000)
}


// pre-Handler for button "rate"
function clickrate(event, r)
{
	// if button is disabled, bail out
	if (document.getElementById("su_thumbup").disabled == true && r == 1)
	{
		// see if they are unrating an old rating
		if (document.getElementById("su_thumbdown").disabled == false)
			su_unrate();
		return;
	}

	// if button is disabled, bail out
	if (document.getElementById("su_thumbdown").disabled == true && r == 0)
	{
		// see if they are unrating an old rating
		if (document.getElementById("su_thumbup").disabled == false)
			su_unrate();
		return;
	}

	if (event.button == 0)
		su_rate(r, 0, 0);
	if (event.button == 2 || event.button == 1)
		su_rate(r, 1, 0);
}


// Handler for button "rate"
function su_unrate() 
{
	su_check_progress_listener();

	// redo su_changeInterval
	clearInterval(su_changeInterval);
	su_changeInterval = setInterval("su_oneMinute()", 300000);

	if (stumbleid == 0)
		return false;
	
	var theurl = getBrowser().contentDocument.location.toString();

	// grey out the buttons until the rating goes through
	document.getElementById("su_thumbup").disabled=true;
	document.getElementById("su_thumbdown").disabled=true;
	document.getElementById("su_thumbdown").setAttribute("onclick", "");
	document.getElementById("su_thumbup").setAttribute("onclick", "");
	document.getElementById("su_thumbdown").setAttribute("onclick", document.getElementById("su_thumbdown").getAttribute("onclick2"));

	unrate_url = theurl;
	unrate_res = su_get_url_server_async('unrate.php?username=' + stumbleid + '&password=' + escape(stumblepass) + '&url=' + escape(theurl) + "&version=" + su_verstring, su_useragent, "", unrate_done);

	su_check_progress_listener();
	return true;
}

function unrate_done()
{
	document.getElementById("su_thumbup").disabled=false;
	document.getElementById("su_thumbdown").disabled=false;
	document.getElementById("su_thumbdown").setAttribute("onclick", document.getElementById("su_thumbdown").getAttribute("onclick2"));
	document.getElementById("su_thumbup").setAttribute("onclick", document.getElementById("su_thumbup").getAttribute("onclick2"));

	var res = unrate_res;
	var theurl = unrate_url;

	if (res.status == 1)
	{
		su_enable_toolbar();
		return false;
	}
	if (res.status != 200)
	{
		su_http_error(res.error, res.status);
		su_enable_toolbar();
		return false;
	}

	var s = res.responseText;
	//!!! need to check here because sometimes we get "s has no properties"

	// Parse response text
	var parsed = s.split("\n");

	// Iterate through commands
	for (var i = 0; i < parsed.length; i++)
	{
		if (parsed[i] == "")
			continue;

		// Parse command structure
		var command = parsed[i].split(" ");
		switch(command[0])
		{
			case "MESSAGE": update_message_status('2'); break;
			case "ERROR":
				su_handle_error(command[1]);
				su_enable_toolbar();
				return false;
				break;	
		}
	}

	var da = new Date();

	// Store in list of rated urls
	su_delete_rating(theurl);

	su_on_new_page(theurl);

	su_check_progress_listener();
	return true;
}

// Handler for button "rate"
function su_rate(r, new_tab, force_nostumble) 
{
	su_check_progress_listener();

	rate_opens_tab = new_tab;

	// If we are opening a comment button in a new tab
	// we shouldn't be stumbling
	if (new_tab == 1)
		force_nostumble = 1;

	var stumble_on_rate = 0;

	// redo su_changeInterval
	clearInterval(su_changeInterval);
	su_changeInterval = setInterval("su_oneMinute()", 300000);

/*
	// is this a comment as opposed to a rating?
	if (comment_rating == r && force_nostumble == 0)
		return su_website_info();
*/

	if (stumbleid == 0)
		return false;
	
	var rating = r;
	var theurl = getBrowser().contentDocument.location.toString();

	// grey out the buttons until the rating goes through
	document.getElementById("su_thumbup").disabled=true;
	document.getElementById("su_thumbdown").disabled=true;
	document.getElementById("su_thumbdown").setAttribute("onclick", "");
	document.getElementById("su_thumbup").setAttribute("onclick", "");
	document.getElementById("su_thumbdown").setAttribute("onclick", document.getElementById("su_thumbdown").getAttribute("onclick2"));

	rate_rating = rating;
	rate_stumble_on_rate = stumble_on_rate;
	rate_url = theurl;
	g_force_nostumble = force_nostumble;
	rate_res = su_get_url_server_async('rate.php?username=' + stumbleid + '&password=' + escape(stumblepass) + '&rating=' + rating + '&url=' + escape(theurl) + "&referer=" + escape(getBrowser().contentDocument.referrer) + "&version=" + su_verstring, su_useragent, "", rate_done);

	su_check_progress_listener();
	return true;
}

function rate_done()
{
	var force_nostumble = g_force_nostumble;	
//	alert("rated url " + rate_url);

	document.getElementById("su_thumbup").disabled=false;
	document.getElementById("su_thumbdown").disabled=false;
	document.getElementById("su_thumbdown").setAttribute("onclick", document.getElementById("su_thumbdown").getAttribute("onclick2"));
	document.getElementById("su_thumbup").setAttribute("onclick", document.getElementById("su_thumbup").getAttribute("onclick2"));

	var res = rate_res;
	var stumble_on_rate = rate_stumble_on_rate;
	var rating = rate_rating;
	var theurl = rate_url;

//	alert(res.response);

	if (res.status == 1)
	{
		su_enable_toolbar();
		return false;
	}
	if (res.status != 200)
	{
		su_http_error(res.error, res.status);
		su_enable_toolbar();
		return false;
	}

	if (stumble_on_rate == 0)
	{
		if ((!bad_stumble && rating == 0) || 
			(!great_stumble && rating == 1)) 
		{
			su_disable_toolbar(rating);
		}
	}

	var myIcon = document.getElementById('su_website-info');
	myIcon.setAttribute("image", "chrome://stumbleupon/content/skin/comment.png");

	var s = res.responseText;
	//!!! need to check here because sometimes we get "s has no properties"

	// Parse response text
	var parsed = s.split("\n");
	var prepend = "";

	var firstrate = 0;

	// Iterate through commands
	for (var i = 0; i < parsed.length; i++)
	{
		if (parsed[i] == "")
			continue;

		// Parse command structure
		var command = parsed[i].split(" ");
		switch(command[0])
		{
			case "URL": prepend += command[1] + "\n"; break;
			case "MESSAGE": update_message_status('2'); break;
			case "FIRSTRATER": firstrate = command[1]; break;
			case "ERROR":
				su_handle_error(command[1]);
				su_enable_toolbar();
				return false;
				break;	
		}
	}

	var da = new Date();

	// Store in list of rated urls
	su_store_rating(theurl, rating);

	rated_url = theurl;

	// Prepend URLs if we got any
	if (prepend != "")
	{
		prior = su_read_file_user("stumbleurls");
		su_write_file_user("stumbleurls", prepend + prior);
	}

	if (!rate_opens_tab && su_pref_getbool('comment_firstrating') && firstrate != 0)
	{
		// fire up a comment tab for the first rating
		var current_page = getBrowser().contentDocument.location.toString();

		var comment = getBrowser().contentWindow.prompt("You are the first stumbler to suggest this page.  Please add a comment for the site:\n\n" + current_page + "\n\n(You can turn off this dialog in Toolbar Options)","");
		if (typeof(comment) != "undefined" && comment != null && comment != '')
		{
			su_get_url_server_async('addcomment.php?urlid=' + firstrate +  "&username=" + escape(stumbleid) + "&password=" + escape(stumblepass) + "&comment=" + escape(comment) + "&version=" + su_verstring, su_useragent, "", null_function);
			// ignore error
		}
	}

	var i_just_stumbled = false;

	// Stumble-On-Rate
	if ((bad_stumble && rating == 0)
		|| (great_stumble && rating == 1) 
		|| (stumble_on_rate == 1)) 
	{
		if (!force_nostumble)
		{
			stumble(0);	
			i_just_stumbled = true;
		}
	}

	if (i_just_stumbled == false && rate_opens_tab)
		su_website_info(1);

	su_check_progress_listener();
	return true;
}

function su_handle_error(error)
{
	auth_server_url('error.php?error=' + error, 0);
}

// Disables one of the rating buttons (denoted by icon)
function su_disable_icon(icon)
{
	var myIcon = document.getElementById('su_' + icon);
	// Check to see if it is already disabled
	myIcon.setAttribute("image", "chrome://stumbleupon/content/skin/green" + icon + ".png");
	
	// disable callback
//	myIcon.setAttribute("onclick", "");
	myIcon.setAttribute("tooltiptext", "Click to unrate this site");
	myIcon.disabled=true;
}

// Enables one of the rating buttons
function su_enable_icon(icon)
{
	var myIcon = document.getElementById('su_' + icon);
	// Check to see if it is already enabled
	myIcon.disabled=false;

	// enable callback
	myIcon.setAttribute("onclick", myIcon.getAttribute("onclick2"));
	myIcon.setAttribute("tooltiptext", myIcon.getAttribute("showtooltiptext"));
	myIcon.setAttribute("image", "chrome://stumbleupon/content/skin/" + icon + ".png");	
}

// Greys out one of the rating buttons
function su_disable_toolbar(rating)
{
	comment_rating = rating;
	comment_url = getBrowser().contentDocument.location.toString();

	// enable everything first so we don't get su_website_info collisions?
	if (rating != 0)
		su_enable_icon("thumbdown");
	if (rating != 1)
		su_enable_icon("thumbup");

	if (rating == 0)
		su_disable_icon("thumbdown");
	if (rating == 1)
		su_disable_icon("thumbup");

	document.getElementById("su_website-info").image="chrome://stumbleupon/content/skin/comment.png";

	su_toolbar_disabled = true;
}

// Un-greys all the rating buttons
function su_enable_toolbar()
{
	comment_rating = -1;
	su_toolbar_disabled = false;
	su_enable_icon("thumbdown");
	su_enable_icon("thumbup");
	if (!document.getElementById("su_website-info").image.indexOf('bubble'))
		document.getElementById("su_website-info").image="chrome://stumbleupon/content/skin/bubble.png";
}

// Handler for when the user hits a new html page
function su_on_new_page(new_url)
{
	// see if we have a firstrater for this tld
	var newtld = su_tld(new_url);
	if (typeof(firstraters[newtld]) != "undefined")
		set_first_rater(firstraters[newtld]);
	else
		clear_first_rater();
	
	// see if we have a topic for this tld
	if (typeof(su_topics[newtld]) != "undefined")
		set_stumble_topic(su_topics[newtld]);
	else
		clear_stumble_topic();
		
	//!!! we do enable all the time to fix thet problem where sometimes the comment button doesn't get cleared?
	if (typeof(su_ratings[new_url]) != "undefined")
		su_disable_toolbar(su_ratings[new_url]);
	else
		su_enable_toolbar();

	// See if this is a stumblers page	
	// only do this is text is on
	if (su_pref_getstring("icons") != "icons-only")
	{
		var stumbler = 0;
		var spliturl = new_url.split("/");
		if (spliturl.length >= 3)
		{
			var domains = spliturl[2].split(".");
			if (domains.length==3 && domains[2] == "com" && domains[1] == "stumbleupon" 
				&& domains[0] != "group"
				&& domains[0] != "irc"
				&& domains[0] != "bugs"
				&& domains[0] != "www"
				&& domains[0] != "search"
				&& domains[0] != "stumblers"
				)
			{
				// we have a stumlber
				stumbler = 1;
			}
		}
	
		if (stumbler)
			document.getElementById("su_thumbup").label=document.getElementById("su_thumbup").getAttribute('showlabel2');
		else
			document.getElementById("su_thumbup").label=document.getElementById("su_thumbup").getAttribute('showlabel');
	}

	// Reset message when we hit the message page
	if (new_url.indexOf('.stumbleupon.com/inbox/')!=-1)
	{
		su_pref_setbool("newmessage", false);
		update_message_status('');
	}

	// disable rating buttons on url pages
	if (new_url.indexOf('http://www.stumbleupon.com/url')!=-1)
	{
		// disable rating buttons
		document.getElementById("su_thumbup").disabled=true;
		document.getElementById("su_thumbdown").disabled=true;
		document.getElementById("su_thumbdown").setAttribute("onclick", "");
		document.getElementById("su_thumbup").setAttribute("onclick", "");

		// nuke info button
		document.getElementById("su_website-info").hidden=true;		
	}
	else
	{
		// if the info button is supposed to be shown, we should show it
		if (su_pref_getorsetbool("show_info", true) && stumbleid != 0)
			document.getElementById("su_website-info").hidden=false;		

		// if the thumb isn't green, we should enable it
		if (document.getElementById("su_thumbdown").image.indexOf('green') == -1)
		{
			document.getElementById("su_thumbdown").disabled=false;
			document.getElementById("su_thumbdown").setAttribute("onclick", document.getElementById("su_thumbdown").getAttribute("onclick2"));

		}
		if (document.getElementById("su_thumbup").image.indexOf('green') == -1)
		{
			document.getElementById("su_thumbup").disabled=false;
			document.getElementById("su_thumbup").setAttribute("onclick", document.getElementById("su_thumbup").getAttribute("onclick2"));
		}
	}

	// Check to see if this page is in our rating history, if so grey out the rating buttons
//	if (su_toolbar_disabled && typeof(su_ratings[new_url]) == "undefined")
//		su_enable_toolbar();
}

// Handler that gets called to see if we need to upload stumbles
// because they are getting stale
function su_oneMinute()
{
	// Check to see if password has changed
	stumblepass = su_pref_getstring("password");

	// Also check to see if we need to upload_stumbles (has it been 1 hour?)
	var da = new Date();
	var timenow = da.getTime();
	var onehour = 15 * 60 * 1000; // javascript stores time in milliseconds

	// so delay can be 15 mins (+ up to 5 mins random_delay)
	if (timenow - su_pref_getstring("last_uploaded") > onehour + su_random_delay*1000 && su_pref_getstring("stumblestats") != "")
		upload_stumbles();
}

// See if we have a user created yet
var getit = su_pref_getstring_absolute("current_user");
if (getit == false)
{
	// no user, see if we need to su_migrate and old user
	var theid = su_read_file_global("stumbleid");
	if (theid != "" && typeof(theid) != "object")
		su_migrate();
	getit = su_pref_getstring_absolute("current_user");
}

if (getit != false)
{
	// We have a user
	if (su_loaded_data != 1)
	{
		get_stumbleid();

		su_load_data1();

		window.addEventListener("load", su_handle_gui_load, false);
	}
}

// su_include extra.js
su_include('chrome://stumbleupon/content/extra.js');

